<?php

//--------------------------------------------------------------------------
//functions area.
//--------------------------------------------------------------------------
function fatale($conn,$function_file)
{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");
echo("Fatal error! in function: $function_file, condition:");
switch($sqlbase) {
  case  'mysql' :
    echo mysql_errno().": ".mysql_error()."<BR>"; 
    break;
  case 'postgresql':
  default:
    if ($conn)
      echo pg_errormessage($conn)."<BR>"; 
    else
      echo ("Database is not open");
    break;
  }
exit;
}
//--------------------------------------------------------------------------
//functions to print a header with code 
//--------------------------------------------------------------------------
function printpage($etiq)
{
$base=getenv("base");
    echo ("<TABLE WIDTH=100%>\n");
    echo ("<TR>\n");
    echo ("<TD ALIGN=RIGHT>\n");
    echo ("<FONT SIZE=-2>$etiq</FONT>\n");
    echo ("</TD>\n");
    echo ("</TR>\n");
    echo ("</TABLE>\n");
include (direcname("$base","footerreg.php"));
}
//--------------------------------------------------------------------------
//functions to print a regadduser.sh shell result.
//--------------------------------------------------------------------------
function printregadd($filer)
{
        $fresult=file_exists($filer);
        if ($fresult) {
           echo ("<CENTER>");
           $fp=fopen($filer,"r");
           $ta=fgets($fp,200);
           $ta2=ereg_replace(" ","&nbsp;",$ta);
           while ($ta) {
              echo ("$ta2 <BR>");
              $ta=fgets($fp,100);
              $ta2=ereg_replace(" ","&nbsp;",$ta);
           } 
           fclose ($fp);
           passthru("rm $filer",$retvalue);
           echo ("</CENTER>");
           }
}
//--------------------------------------------------------------------------
//Verification du emailid et du temps access (max 20 minutes)               
//--------------------------------------------------------------------------
function checktime_id($conn,$base,$userid,$codeid)
{
  if ($userid) {
    $pat="where userid='$userid' and codeid='$codeid' and start>now()- interval '20 minute'";
    
    $result=simplesearch($conn,$pat,"secure_cust");
    $rows=numrows($result);
    if ($rows>0) {
      return true;
    }
    else {
      $pat="where userid='$userid' and codeid='$codeid' ";
      
      $result=simplesearch($conn,$pat,"secure_cust");
      $rows=numrows($result);

      if ($rows==0) {
	write_log_client($base,'Invalid indentification',$userid,'');
  
  
      }
      else
	write_log_client($base,'codeid expired',$userid,'');
      return false;
    }
  }
  else {
    write_log_client($base,'No userid',$userid,'');
    return false;
  }
  
}

//--------------------------------------------------------------------------
//functions to return the name in conf, conf/html or html.
//--------------------------------------------------------------------------
function direcname($base,$namefile)
{
$namei=sprintf("%s/conf/%s",$base,$namefile);
$result=file_exists($namei);
if ($result)
  return $namei;
else
  {
  $namei=sprintf("%s/conf/html/%s",$base,$namefile);
  $result=file_exists($namei);
  if ($result)
    return $namei;
  else
    {
    $namei=sprintf("%s/html/%s",$base,$namefile);
    $result=file_exists($namei);
    if ($result)
      return $namei;
    else
      {
      return $namefile;
      }
    }
  }

}
//--------------------------------------------------------------------------
//functions to return the name in conf, conf/html or html.
//--------------------------------------------------------------------------
function direcnamec($base,$namefile)
{
$namei=sprintf("%s/conf/%s",$base,$namefile);
$result=file_exists($namei);
if ($result)
  return $namei;
else
  {
  $namei=sprintf("%s/conf/htmlcust/%s",$base,$namefile);
  $result=file_exists($namei);
  if ($result)
    return $namei;
  else
    {
    $namei=sprintf("%s/htmlcust/%s",$base,$namefile);
    $result=file_exists($namei);
    if ($result)
      return $namei;
    else
      {
      return $namefile;
      }
    }
  }

}
//--------------------------------------------------------------------------
//functions to return the  html.
//--------------------------------------------------------------------------
function direchtml($base,$namefile)
{

    $namei=sprintf("%s/html/%s",$base,$namefile);
    $result=file_exists($namei);
    if ($result)
      return $namei;
    else
      {
      return $namefile;
      }

}
//--------------------------------------------------------------------------
//functions to return the  html.
//--------------------------------------------------------------------------
function direchtmlc($base,$namefile)
{

    $namei=sprintf("%s/htmlcust/%s",$base,$namefile);
    $result=file_exists($namei);
    if ($result)
      return $namei;
    else
      {
      return $namefile;
      }

}
//--------------------------------------------------------------------------
//functions to check thie file is in conf/html.
//--------------------------------------------------------------------------
function specialhtml($base,$namefile)
{

    $namei=sprintf("%s/conf/html/%s",$base,$namefile);
    $result=file_exists($namei);
    if ($result)
      return TRUE;
    else
      {
      return FALSE;
      }

}
function specialhtmlc($base,$namefile)
{

    $namei=sprintf("%s/conf/htmlcust/%s",$base,$namefile);
    $result=file_exists($namei);
    if ($result)
      return TRUE;
    else
      {
      return FALSE;
      }

}
//--------------------------------------------------------------------------
//functions to return the name in conf/shell or shell.
//--------------------------------------------------------------------------
function goodshell($base,$namefile)
{

$namei=sprintf("%s/conf/shell/%s",$base,$namefile);
$result=file_exists($namei);
if ($result)
  return $namei;
else
  {
  $namei=sprintf("%s/shell/%s",$base,$namefile);
  $result=file_exists($namei);
  return $namei;
  }
}
//--------------------------------------------------------------------------
//functions to return the name in conf/shell or shell.
//--------------------------------------------------------------------------
function goodbin($base,$namefile)
{

$namei=sprintf("%s/conf/bin/%s",$base,$namefile);
$result=file_exists($namei);
if ($result)
  return $namei;
else
  {
  $namei=sprintf("%s/bin/%s",$base,$namefile);
  $result=file_exists($namei);
  return $namei;
  }
}
//--------------------------------------------------------------------------
//functions to return the name with lang
//--------------------------------------------------------------------------
function namelang($namefile,$lang)
{
switch($lang) {
  case  'Francais'  :
    $filelang=sprintf("%s%s",$namefile,'.fra.php');
    break;
  case  'English'  :
  default:
    $filelang=sprintf("%s%s",$namefile,'.eng.php');
    break;
  }
return $filelang;

}
//--------------------------------------------------------------------------
//functions to return the name in conf, conf/html or html.
//--------------------------------------------------------------------------
function hrefname($base,$namefile)
{

$namei=sprintf("%s/conf/%s",$base,$namefile);
$result=file_exists($namei);
if ($result)
  {
  $namei=sprintf("/base-dir/conf/%s",$namefile);
  return $namei;
  }
else
  {
  $namei=sprintf("%s/conf/html/%s",$base,$namefile);
  $result=file_exists($namei);
  if ($result)
    {
    $namei=sprintf("/base-dir/conf/html/%s",$namefile);
    return $namei;
    }
  else
    {
    $namei=sprintf("%s/html/%s",$base,$namefile);
    $result=file_exists($namei);
    if ($result)
      {
      $namei=sprintf("/base-dir/html/%s",$namefile);
      return $namei;
      }
    else
      {
      return $namefile;
      }
    }
  }

}
//--------------------------------------------------------------------------
//functions to return the name in conf, conf/html or html for POST and GET
//--------------------------------------------------------------------------
function hrefnameform($base,$namefile)
{
$namefile=hrefname($base,$namefile);
return $namefile;
}
//--------------------------------------------------------------------------
//functions to return the name in conf, conf/html or html.
//--------------------------------------------------------------------------
function hrefnamec($base,$namefile)
{

$namei=sprintf("%s/conf/%s",$base,$namefile);
$result=file_exists($namei);
if ($result)
  {
  $namei=sprintf("/base-dir/conf/%s",$namefile);
  return $namei;
  }
else
  {
  $namei=sprintf("%s/conf/htmlcust/%s",$base,$namefile);
  $result=file_exists($namei);
  if ($result)
    {
    $namei=sprintf("/base-dir/conf/htmlcust/%s",$namefile);
    return $namei;
    }
  else
    {
    $namei=sprintf("%s/htmlcust/%s",$base,$namefile);
    $result=file_exists($namei);
    if ($result)
      {
      $namei=sprintf("/base-dir/htmlcust/%s",$namefile);
      return $namei;
      }
    else
      {
      return $namefile;
      }
    }
  }

}

//--------------------------------------------------------------------------
//Function to explore the data-base
//--------------------------------------------------------------------------
function diffsearch($conn,$pattern,$namefile,$paramet)

{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");
//echo ("paramet=$paramet");
//echo ("name=$namefile");
//echo ("patt=$pattern");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","SELECT $paramet FROM $namefile $pattern");
    break;
  case 'postgresql' :
  default:
    //      echo ("SELECT $paramet FROM $namefile $pattern;");
    $result=pg_exec($conn,"SELECT $paramet FROM $namefile $pattern;");
    break;
  }
if (!$result)
  fatale($conn,'diffsearch');
return $result;
}
//--------------------------------------------------------------------------
//Function to explore the data-base
//--------------------------------------------------------------------------
function simplesearch($conn,$pattern,$namefile)

{
  //    echo ("pat=$pattern");
// echo ("name=$namefile<BR>");
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","SELECT * FROM $namefile $pattern");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"SELECT * FROM $namefile $pattern;");
    break;
  }

if (!$result)
  fatale($conn,'simplesearch');
return $result;
}
//--------------------------------------------------------------------------    
//Function to explore the data-base                                             
//--------------------------------------------------------------------------    
function makevacuum($conn)

{
  //  echo ("pat=$pattern");
  //echo ("name=$namefile<BR>");
  $sqlbase=getenv("sqlbase");
  $dbase=getenv("dbase");

  switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","vacuum");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"vacuum analyse;");
    break;
  }

  if (!$result)
    fatale($conn,'makevacuum');
  return $result;
}

//--------------------------------------------------------------------------
//Function to create view
//--------------------------------------------------------------------------
function simpleview($conn,$pattern,$namefile,$namev,$var)

{
//echo ("pat=$pattern");
//echo ("name=$namefile<BR>");
//echo ("var=$var<BR>");
//echo ("namev=$namev<BR>");
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","create view $namev as select $var FROM $namefile $pattern");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"create view $namev as select $var FROM $namefile $pattern;");
    break;
  }

if (!$result)
  fatale($conn,'simpleview');
return $result;
}
//--------------------------------------------------------------------------
//Function to drop view
//--------------------------------------------------------------------------
function dropview($conn,$namev)

{
//echo ("name=$namefile<BR>");
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","drop view $namev");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"drop view $namev;");
    break;
  }

if (!$result)
  fatale($conn,'dropview');
return $result;
}
//--------------------------------------------------------------------------
//Function to explore the data-base
//--------------------------------------------------------------------------
function simplesearchd($conn,$field,$namefile,$pattern)

{
//echo ("filed=$field");
//echo ("name=$namefile<BR>");
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","SELECT distinct $field FROM $namefile $pattern");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"SELECT distinct $field FROM $namefile $pattern;");
    break;
  }

if (!$result)
  fatale($conn,'simplesearchd');
return $result;
}
//--------------------------------------------------------------------------
//Function to return number of transaction
//--------------------------------------------------------------------------
function howmany($result)

{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $nbr=mysql_affected_rows();
    break;
  case 'postgresql' :
  default:
    $nbr=pg_cmdtuples($result); 
    break;
  }

return $nbr;
}
//--------------------------------------------------------------------------
//Function to explore the data-base
//--------------------------------------------------------------------------
function howmanycount($conn,$pattern,$namefile)

{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");
//echo ("<BR>patt=$pattern");
//echo ("namefile=$namefile");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","SELECT count(*) FROM $namefile $pattern");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"SELECT count(*) FROM $namefile $pattern;");
    break;
  }

if (!$result)
  fatale($conn,'howmanycount');
$nbr=getresult($result,0,0);

return $nbr;
}
//--------------------------------------------------------------------------
//Function to explore the data-base
//--------------------------------------------------------------------------
function howmanycountd($conn,$field,$namefile,$pattern)

{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","SELECT count(distinct $field) FROM $namefile $pattern");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"SELECT count(distinct $field) FROM $namefile $pattern;");
    break;
  }

if (!$result)
  fatale($conn,'howmanycountd');
$nbr=getresult($result,0,0);

return $nbr;
}
//--------------------------------------------------------------------------
//Function to calcul sum
//--------------------------------------------------------------------------
function calculsum($conn,$field,$namefile,$pattern)

{

$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");
switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","SELECT sum($field) FROM $namefile $pattern");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"SELECT sum($field) FROM $namefile $pattern;");
    break;
  }

if (!$result)
  fatale($conn,'calculsum');
$total=getresult($result,0,0);

return $total;
}
//--------------------------------------------------------------------------
//Function to explore the data-base
//--------------------------------------------------------------------------
function simpledelete($conn,$pattern,$namefile)

{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");
//echo ("patt=$pattern");
//echo ("name=$namefile");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","DELETE FROM $namefile $pattern");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"DELETE FROM $namefile $pattern;");
    break;
  }

if (!$result)
  fatale($conn,'simpledelete');
return $result;
}

//--------------------------------------------------------------------------
//Function to explore the data-base
//--------------------------------------------------------------------------
function simpleupdate($conn,$userid,$pattern,$namefile)

{
  //echo ("Uname='$namefile'");
//echo ("Upattern=$pattern");
//echo ("Uuserid='$userid'\n");
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");
switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","UPDATE $namefile set $pattern where userid='$userid'");
    break;
  case 'postgresql' :
  default:
//    echo ("<BR>UPDATE $namefile set $pattern where userid='$userid';");
    $result=pg_exec($conn,"UPDATE $namefile set $pattern where userid='$userid';");
    break;
  }

if (!$result)
  fatale($conn,'simpleupdate');
return $result;
}
//--------------------------------------------------------------------------
//Function to explore the data-base
//--------------------------------------------------------------------------
function cptupdate($conn,$pat,$pattern,$namefile)

{
  /*
echo ("Upattern=$pattern");
echo ("<BR>");
echo ("Ukey='$pat'\n");
echo ("<BR>");
echo ("Uname='$namefile'\n");
echo ("<BR>");
  */
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","UPDATE $namefile set $pattern where $pat");
    break;
  case 'postgresql' :
  default:
    //    echo ("UPDATE $namefile set $pattern where $pat;");
    $result=pg_exec($conn,"UPDATE $namefile set $pattern where $pat;");
    break;
  }
if (!$result)
  fatale($conn,'cptupdate');
return $result;
}
//--------------------------------------------------------------------------
//Function to explore the data-base
//--------------------------------------------------------------------------
function simplewrite($conn,$pattern,$namefile)

{
  //echo ("Uname='$namefile'");
  //echo ("Upattern=$pattern");
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
   $var2='empty';
   switch($namefile) {
     case  userreg :
     case  userbill :
     case  specific :
     case  regspecific :
        $var1='userid';
        break;
     case  invoiced :
	$pos=strrpos($pattern,","); 
	if ($pos>0)
          $var1='numcnt,product';
	else
          $var1='numcnt';
        break;
     case  contract :
        $var1='numcnt';
        break;
     case  deposit :
        $var1='datestart,datestop,row';
        break;
     case  otherprod :
        $var1='userid,otherprod,qop,dop,otype,siteweb';
        break;
     case  terminal :
        $var1='termname';
        break;
     case  comments :
     case  timeframes :
     case  groupe :
     case  dial :
        $var2='full';
        break;
     case  counters :
        $var1='cptname';
        break;
     case  huntgroup :
        $var1='huntgrp';
        break;
     case  collected :
        $var1='numcnt,numcoll';
        break;
     case  retailer :
        $var1='retailer';
        break;
     case  products :
     case  prices :
        $var1='prodname';
        break;
     case  packages :
	$pos=strrpos($pattern,","); 
	if ($pos>0)
        $var1='packname,prodname,ptype,qprod';
        else
        $var1='packname';
        break;
     case  web :
	$pos=strrpos($pattern,","); 
	if ($pos>0)
        $var1='prodname,definition,numcnt,billedto';
        else
        $var1='prodname';
        break;
     case  other :
	$pos=strrpos($pattern,","); 
	if ($pos>0)
        $var1='prodname,definition,qop,numcnt,billedto';
        else
        $var1='prodname';
        break;
   }
//echo ("var1=$var1");
//echo ("var2=$var2");
    if ($var2=='full')
      $result=mysql_db_query("$dbase","INSERT into $namefile values($pattern)");
    else
      $result=mysql_db_query("$dbase","INSERT into $namefile($var1) values($pattern)");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"INSERT into $namefile values($pattern);");
    break;
  }

if (!$result)
  fatale($conn,'simplewrite');
return $result;
}
//--------------------------------------------------------------------------
//Function to explore the data-base
//--------------------------------------------------------------------------
function simplewritei($conn,$pattern)

{
//echo ("Uname='$namefile'");
//echo ("Upattern=$pattern");
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
   $var1='numcnt,product,userid,canbecancel,startt,endt,quantity';
      $result=mysql_db_query("$dbase","INSERT into invoiced($var1) values($pattern)");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"INSERT into invoiced values($pattern);");
    break;
  }

if (!$result)
  fatale($conn,'simplewritei');
return $result;
}
//--------------------------------------------------------------------------
//Function to find the deposit number
//--------------------------------------------------------------------------
function courdeposit($conn)

{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","select deposit from info");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"select deposit from info;");
    break;
  }

if (!$result)
  fatale($conn,'courdeposit');
return $result;
}
//--------------------------------------------------------------------------
//Function to find the new deposit number
//--------------------------------------------------------------------------
function newdeposit($conn,$today)

{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");


switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","update info set deposit='$today'");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"update info set deposit='$today';");
    break;
  }
if (!$result)
  fatale($conn,'newdeposit');
return $result;
}
//--------------------------------------------------------------------------
//Function to add nbrchange + 1 to info
//--------------------------------------------------------------------------
function updateinfo($conn)

{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

$patlic="";
$resultl=simplesearch($conn,$patlic,"info");
$nbrchange=getresult($resultl,0,'nbrchange');

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","update info set nbrchange=nbrchange+1");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"update info set nbrchange=nbrchange+1;");
    break;
  }


if (!$result)
  fatale($conn,'updateinfo');
return $result;
}
//--------------------------------------------------------------------------
//Function to add nbrchange + 1 to info
//--------------------------------------------------------------------------
function updaterestart($conn)

{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

$patlic="";
$resultl=simplesearch($conn,$patlic,"info");
$restart=getresult($resultl,0,'restart');

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","update info set restart='Y'");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"update info set restart='Y';");
    break;
  }
if (!$result)
  fatale($conn,'updaterestart');
return $result;
}
//--------------------------------------------------------------------------
//Function to find the new contract number
//--------------------------------------------------------------------------
function newnumcon($conn,$plus)
 
{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","insert into contract(numcnt) values(NULL)");
    if ($plus>1) {
    $plus=$plus-2;
    $result=mysql_db_query("$dbase","DELETE FROM contract WHERE numcnt=LAST_INSERT_ID()");
    $result=mysql_db_query("$dbase","INSERT INTO contract (numcnt) values(LAST_INSERT_ID()+$plus)");
    $result=mysql_db_query("$dbase","DELETE FROM contract WHERE numcnt=(LAST_INSERT_ID()+$plus)");
    $result=mysql_db_query("$dbase","INSERT INTO contract (numcnt) values(NULL)");

    }
    $nombre=mysql_insert_id();
    $result=mysql_db_query("$dbase","delete from contract where numcnt=$nombre");
    break;
  case 'postgresql' :
  default:
    if ($plus==1) {
     $result=pg_exec($conn,"select nextval('contract_numcnt_seq');");
     }
    else {
     $plus=$plus-1;
     $result=pg_exec($conn,"select setval('contract_numcnt_seq',nextval('contract_numcnt_seq')+$plus);");
    }
    $nombre=getresult($result,0,0);
    cleanresult($result);
    break;
  }

if (!$result)
  fatale($conn,'newnumcon');
return $nombre;
}
//--------------------------------------------------------------------------
//Function to find the new link contract number
//--------------------------------------------------------------------------
function newnumconl($conn,$plus)
 
{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","insert into conlink(numcnt) values(NULL)");
    if ($plus>1) {
    $plus=$plus-2;
    $result=mysql_db_query("$dbase","DELETE FROM conlink WHERE numcnt=LAST_INSERT_ID()");
    $result=mysql_db_query("$dbase","INSERT INTO conlink (numcnt) values(LAST_INSERT_ID()+$plus)");
    $result=mysql_db_query("$dbase","DELETE FROM conlink WHERE numcnt=(LAST_INSERT_ID()+$plus)");
    $result=mysql_db_query("$dbase","INSERT INTO conlink (numcnt) values(NULL)");

    }
    $nombre=mysql_insert_id();
    $result=mysql_db_query("$dbase","delete from conlink where numcnt=$nombre");
    break;
  case 'postgresql' :
  default:
    if ($plus==1) {
     $result=pg_exec($conn,"select nextval('conlink_numcnt_seq');");
     }
    else {
     $plus=$plus-1;
     $result=pg_exec($conn,"select setval('conlink_numcnt_seq',nextval('conlink_numcnt_seq')+$plus);");
    }
    $nombre=getresult($result,0,0);
    cleanresult($result);
    break;
  }

if (!$result)
  fatale($conn,'newnumconl');
return $nombre;
}
//--------------------------------------------------------------------------
//Function to return the row number
//--------------------------------------------------------------------------
function numrows($result)

{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");


switch($sqlbase) {
  case  'mysql' :
   return mysql_num_rows($result);
    break;
  case 'postgresql' :
  default:
    return pg_numrows($result);
    break;
  }
}

//--------------------------------------------------------------------------
//Function to clean the result field
//--------------------------------------------------------------------------
function cleanresult($result)

{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

//echo ("Clean result=$result");
switch($sqlbase) {
  case  'mysql' :
    switch($result) {
    case 0:
    case 1:
      break;
    default:
      mysql_free_result($result);
    }
    break;
  case 'postgresql' :
  default:
    pg_freeresult($result);
    break;
  }
}
//--------------------------------------------------------------------------
//Function to close file
//--------------------------------------------------------------------------
function closefile($conn)

{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");
switch($sqlbase) {
  case  'mysql' :
    mysql_close($conn);
    break;
  case 'postgresql' :
  default:
    pg_close($conn);
    break;
  }
}
//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
//Function to return a field in a row
//--------------------------------------------------------------------------
function getresult($result,$row,$field)

{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");
switch($sqlbase) {
  case  'mysql' :
    return mysql_result($result,$row,$field);
    break;
  case 'postgresql' :
  default:
    return pg_result($result,$row,$field);
    break;
  }


}

//-------------------------------------------------------------------------
//Function find the quantity of month bettween 2 dates
//-------------------------------------------------------------------------
function trouvesec($datee)

{
  $annee=substr($datee,0,4);
  $pos=strpos($datee,"-");
   if ($pos==4) {
     $mois=substr($datee,5,2);
     $jour=substr($datee,8,2);
    }
   else {
     $mois=substr($datee,4,2);
     $jour=substr($datee,6,2);
   }
  $fin=mktime(12,00,00,$mois,$jour,$annee);
  return $fin;

}
//-------------------------------------------------------------------------
//Function find the quantity of month bettween 2 dates
//-------------------------------------------------------------------------
function diffmonths($nbm,$debut,$fin)

{
$sdate=date("Y-m-d",$debut);
$annee=substr($sdate,0,4);
$mois=substr($sdate,5,2);
$jour=substr($sdate,8,2);
$fin=$fin+(24*3600);
$edate=date("Y-m-d",$fin);
for ($calc=0;$edate>date("Y-m-d",mktime(0,0,0,$mois+(($calc+1)*$nbm),$jour,$annee));$calc++);
$debrest=trouvesec(date("Y-m-d",mktime(0,0,0,$mois+($calc*$nbm),$jour,$annee)));
$maxrest=trouvesec(date("Y-m-d",mktime(0,0,0,$mois+(($calc+1)*$nbm),$jour,$annee)));
return (((float)($fin-$debrest))/($maxrest-$debrest))+$calc; 
}

//-------------------------------------------------------------------------
//Function find the quantity of month bettween 2 dates
//-------------------------------------------------------------------------
function diffdate($mode,$dates,$datee)

{
  //  echo ("<BR> mode=$mode  dates=$dates datee=$datee");
  if ($dates>$datee) 
    $calcul=0;
  else {

  $fin=trouvesec($datee);
  $debut=trouvesec($dates);

  $difference=$fin-$debut+(3600*24);
  $calcul=0.0;
  switch($mode) {
  case  s  :
    $calcul=$difference;
    break;
  case  m  :
    $calcul=$difference/60;
    break;
  case  H  :
    $calcul=$difference/3600;
    break;
  case  D  :
    $calcul=$difference/(3600*24);
    break;
  case  W  :
    $calcul=$difference/(3600*24*7);
    break;
  case  F  :
    $calcul=1.0;
    break;
  case  T  :
    $calcul=diffmonths(3,$debut,$fin);
    break;
  case  S  :
    $calcul=diffmonths(6,$debut,$fin);
    break;
  case  Y  :
    $calcul=diffmonths(12,$debut,$fin);
    break;
  case  M  :
  default:
    $calcul=diffmonths(1,$debut,$fin);
    break;
  }
  }
$calcul=sprintf("%.2f",$calcul);
return $calcul;
}
//-------------------------------------------------------------------------
//Function convert seconds (depends mode in prices)
//-------------------------------------------------------------------------
function convertsec($mode,$valeur)

{
  switch($mode) {
  case  s  :
    $calcul=$valeur;
    break;
  case  m  :
    $calcul=$valeur/60;
    break;
  case  H  :
    $calcul=$valeur/3600;
    break;
  case  D  :
    $calcul=$valeur/(3600*24);
    break;
  case  W  :
    $calcul=$valeur/(3600*24*7);
    break;
  case  F  :
    $calcul=1.0;
    break;
  case  T  :
    $calcul=$valeur/(3600*24*30*4);
    break;
  case  S  :
    $calcul=$valeur/(3600*24*30*6);
    break;
  case  Y  :
    $calcul=$valeur/(3600*24*30*12);
    break;
  case  M  :
  default:
    $calcul=$valeur/(3600*24*30);
    break;
  }
$calcul=sprintf("%.6f",$calcul);
return $calcul;
}

//-------------------------------------------------------------------------
//Function convert bytes to unit  (depends unit in prices)
//-------------------------------------------------------------------------
function convertunit($mode,$valeur)

{
  switch($mode) {
  case  K  :
    $calcul=$valeur/1024;
    break;
  case  M  :
    $calcul=$valeur/(1024*1024);
    break;
  case  G  :
    $calcul=$valeur/(1024*1024*1024);
    break;
  case  B  :
  default:
    $calcul=$valeur;
    break;
  }
$calcul=sprintf("%.2f",$calcul);
return $calcul;
}


//-------------------------------------------------------------------------
//Function find the quantity of month bettween 2 dates
//-------------------------------------------------------------------------
function chdate($date1)

{

   $annee=substr($date1,0,4);
   $pos=strpos($date1,"-");
   if ($pos==4) {
     $mois=substr($date1,5,2);
     $jour=substr($date1,8,2);
    }
   else {
     $mois=substr($date1,4,2);
     $jour=substr($date1,6,2);
   }
  return checkdate($mois,$jour,$annee);
}

//-------------------------------------------------------------------------
//complete date
//-------------------------------------------------------------------------
function loaddate($date1)


{
$dateempty='NULL';

$long=strlen($date1);
for ($i=0;$i<$long;$i++) {
    if ($date1[$i]!='-')
       if (($date1[$i]>='0') and ($date1[$i]<='9')) 
           $newvalue=sprintf("%s%s",$newvalue,$date1[$i]);
        }

if (substr($newvalue,0,8)<='19700101')
  return $dateempty;

if ($date1=='') 
  return $dateempty;
  
if (chdate($date1)) {
  $date2=sprintf("'%s'",$date1);
  return $date2;
 }
else
  return $dateempty;

}

//--------------------------------------------------------------------------
//Function to list the choice
//--------------------------------------------------------------------------
function listchoice($conn,$usr,$action,$choix,$userid,$bill,$choicekey,$base,$lang,$nbusr)
{
  echo ("<TR>\n");
  echo ("<TD ALIGN=CENTER>\n");
  if ($bill) { 
  if ($choicekey[0]!='') {
      $namedir=hrefname("$base","updsu1.php");
    echo ("<A HREF=\"$namedir?&lang=$lang&userid=$bill&action=search\">");
    echo ("$choicekey[0]\n");
    echo ("</A>");
  if ($choicekey[1]!='') 
    echo ("/");
    }
  if ($choicekey[1]!='') {
    $namedir=hrefname("$base","usrlog1.php");
    echo ("<A HREF=\"$namedir?&lang=$lang&userid=$bill&action=search\">");
    echo ("$choicekey[1]\n");
    echo ("</A>");
    }
  }
  echo ("</TD>\n");
  echo ("<TD ALIGN=CENTER>\n");
  if ($bill) {
  $chgrp=array('support','minimal');
if (checkgrp($conn,$usr,$chgrp)) {
  $namedir=hrefname("$base","disppr1.php");
}
else {
  $namedir=hrefname("$base","updpr1.php");
}
  echo ("<A HREF=\"$namedir?&lang=$lang&userid=$bill&action=search\">");
  echo ("$choicekey[2]\n");
    echo ("</A>");
  $chgrp=array('support','minimal');
if (checkgrp($conn,$usr,$chgrp)) {
}
else {
  if ($choicekey[3]!='') 
    echo ("/");
  if ($choicekey[3]!='') {
    $namedir=hrefname("$base","statbill.php");
    echo ("<A HREF=\"$namedir?&lang=$lang&rech=$bill&display=yes&okpaid=N&action=search\">");
    echo ("$choicekey[3]\n");
    echo ("</A>");
    }
   }
  }
  echo ("</TD>\n");
  echo ("<TD ALIGN=CENTER>\n");
  if ($nbusr<>0) {
  $chgrp=array('minimal');

if (checkgrp($conn,$usr,$chgrp)) {
}
 else {
    $namedir=hrefname("$base","updpass.php");
    echo ("<A HREF=\"$namedir?&lang=$lang&userid=$userid&action=\"display\"\">");
    echo ("$choicekey[4]</A> \n");
 }
  }
  echo ("</TD>\n");
  echo ("<TD ALIGN=CENTER>\n");
  if ($nbusr<>0) {
  $namedir=hrefname("$base","dispusr.php");
  echo ("<A HREF=\"$namedir?&lang=$lang&userid=$userid&action=\"display\"\">");
  echo ("$choicekey[5]</A>\n");
  if ($choicekey[6]) {
  $namedir=hrefname("$base","confir.php");
  echo ("/\n");
  echo ("<A HREF=\"$namedir?&lang=$lang&userid=$userid&action=\"display\"\">");
  echo ("$choicekey[6]</A>\n");
  }
  }
  echo ("</TD>\n");
  echo ("</TR>\n");
  echo ("<TR>\n");
  $nbch=sizeof($choix);
  if ($nbch==4)
    $nbch2=3;
  else
    $nbch2=$nbch;

$chgrp=array('support','minimal');
if (checkgrp($conn,$usr,$chgrp)) {
  if ($choix[0])  {
  echo ("<TD ALIGN=CENTER WIDTH=25%>\n");
  echo ("<CENTER><INPUT TYPE=SUBMIT NAME=\"action\" VALUE=\"$choix[0]\"></CENTER>\n");
  echo ("</TD>\n"); 
}
  if ($choix[1]) {
  echo ("<TD ALIGN=CENTER WIDTH=25%>\n");
  echo ("<CENTER><INPUT TYPE=SUBMIT NAME=\"action\" VALUE=\"$choix[1]\"></CENTER>\n");
  echo ("</TD>\n"); 
  }
  else {
    echo ("<TD ALIGN=CENTER WIDTH=25%>\n");
    echo ("&nbsp;</TD>");
  }
  if ($choix[2]) {
  echo ("<TD ALIGN=CENTER WIDTH=25%>\n");
  echo ("<CENTER><INPUT TYPE=SUBMIT NAME=\"action\" VALUE=\"$choix[2]\"></CENTER>\n");
  echo ("</TD>\n"); 
  }
}
else {
  for ($i=0;$i<$nbch2;$i++) {
  echo ("<TD ALIGN=CENTER WIDTH=25%>\n");
  if ($choix[$i]) 
  echo ("<CENTER><INPUT TYPE=SUBMIT NAME=\"action\" VALUE=\"$choix[$i]\"></CENTER>\n");
  echo ("</TD>\n"); 
  }
  if ($nbch==4) {
  echo ("<TD ALIGN=CENTER WIDTH=25%>\n");
  $namedir=hrefname("$base","delusr.php");
  echo ("<A HREF=\"$namedir?&lang=$lang&userid=$userid&action=\"delete\"\">");
  echo ("$choix[$i]");
  echo ("</TD>\n"); 

  }
}
  echo ("</TR>\n");
}
//--------------------------------------------------------------------------
//Function to list search
//--------------------------------------------------------------------------
function listsearch($action,$choix)
{
  echo ("<TR>\n");
  echo ("<TD ALIGN=CENTER WIDTH=100% COLSPAN=4>\n");
  echo ("<CENTER><INPUT TYPE=SUBMIT NAME=\"action\" VALUE=\"$choix\"></CENTER>\n");
  echo ("</TD>\n"); 
  echo ("</TR>\n");
}
//--------------------------------------------------------------------------
//Function to explore the data-base
//--------------------------------------------------------------------------
function searchuser($conn,$addr_ip,$phpuser)

{
if ($addr_ip) {
  $pattern = "WHERE ipnum = '$addr_ip'";
  $result=simplesearch($conn,$pattern,"useronline");
  $rows=numrows($result);
  if ($rows>=1) {
    $userid=getresult($result,0,'username');                               
    }
  else
    $userid=$phpuser;
  }
else
  $userid=$phpuser;
return $userid;
}
//--------------------------------------------------------------------------
//Function to find the invoice header and footer
//--------------------------------------------------------------------------
function findfile($conn,$base,$revend,$type,$clang)

{
switch($type) {
  case  head  :
    $namedef='headerinv.html';
    break;
  case  invf  :
    $namedef='footer.html';
    break;
  case  staf  :
    $namedef='state.html';
    break;
 case  call  :
     $namedef='call';
     if ($clang)
       $namedef .= '.';
     $namedef .= $clang;
     $namedef .= '.html';
   break;
 default:
    return $namedef;
  }
if ($revend) {
  $pattern="WHERE retailer= '$revend'";
  $result=simplesearch($conn,$pattern,"retailer");
  $rows=numrows($result);
  if ($rows==1) {
    switch($type) {
      case  head  :
         $name=getresult($result,0,'invheader');
	 break;
      case  invf  :
         if ($clang=="English") 
           $name=getresult($result,0,'invfooter');
	 else
           $name=getresult($result,0,'invfooterf');
	 break;
      case  staf  :
         if ($clang=="English")  
           $name=getresult($result,0,'stafooter');
	 else 
           $name=getresult($result,0,'stafooterf');
	break;
      }
    }
  else {
    $name=$namedef;
    }
  cleanresult($result);
  }
else {
  $name=$namedef;
  }
if ($name) {
$name=direcname("$base",$name);
$result=file_exists($name);
if ($result) {
  return $name;
  }
else {
  $name=direcname("$base",$namedef);
  $result=file_exists($name);
  if ($result) {
    return $name;
    }
  else
    return;
  }
}
else  {
  $name=direcname("$base",$namedef);
  $result=file_exists($name);
  if ($result) {
    return $name;
    }
  else
  return;
}
return 0;
}
//--------------------------------------------------------------------------
function convmode($mode)

{
$first=substr($mode,0,1);
$lenmode=strlen($mode)-1;
if (($first=='+') or ($first=='-'))
   $newmode=substr($mode,1,$lenmode);
else
   $newmode=$mode;
return $newmode;
}
//--------------------------------------------------------------------------
function loadpr($conn,$pattern,$cbill,$newprod,$pquan,$pdisc,$provtaxe,$prixpromo)

{
    $pat2= "WHERE userid = '$cbill'";
    $result2=simplesearch($conn,$pat2,"userbill");
    $rows2=numrows($result2);
    if ($rows2==1) {
      $flagtaxe=getresult($result2,0,'usertaxe');
      if ($flagtaxe==1) {
        $tax1=getresult($result2,0,'utaxe1');
        $tax2=getresult($result2,0,'utaxe2');
        $tax3=getresult($result2,0,'utaxe3');
       }
    }
    cleanresult($result2);
    /*
    $pat2="where promotion='$newprod'";
    $result2=simplesearch($conn,$pat2,"promotion");
    $rows2=numrows($result2);
    if ($rows2>0) {
      $newprod=getresult($result2,0,'product');
      if (!$datepromo) {
	$today=date("Y-m-d");
	$pattern2="datepromo='$today'";
	$pat2="userid = '$cbill'";
	$result=cptupdate($conn,$pat2,$pattern2,"userbill");
	$datepromo=$today;
      }
    }
    */
    $pat2= "WHERE prodname= '$newprod'";
    $result2=simplesearch($conn,$pat2,"prices");
    $rows2=numrows($result2);
    if ($rows2>0) {
      $amount=getresult($result2,0,'cost');
      $params=getresult($result2,0,'params');
      $taxeprod=getresult($result2,0,'taxeprod');
      if ($taxeprod=='Y') {
	    $tax1=getresult($result2,0,'taxe1');
	    $tax2=getresult($result2,0,'taxe2');
	    $tax3=getresult($result2,0,'taxe3');
      }
      if ($cost==0) {
        $amountb=getresult($result2,0,'costbyteout');
	if ($amountb>0)
          $amount=$amountb;
      }
      if ($prixpromo) {
	$amount=$prixpromo;
      }
      if (($taxeprod<>'Y')  and ($flagtaxe==0)) {
	if ($provtaxe) {
	  $pat2= "WHERE province= '$provtaxe'";
	  $result2t=simplesearch($conn,$pat2,"taxes");
	  $rows2t=numrows($result2t);
	  if ($rows2t==1) {
	    $tax1=getresult($result2t,0,'taxe1');
	    $tax2=getresult($result2t,0,'taxe2');
	    $tax3=getresult($result2t,0,'taxe3');
	  }
	  else {
	  $tax1=getresult($result2,0,'taxe1');
	  $tax2=getresult($result2,0,'taxe2');
	  $tax3=getresult($result2,0,'taxe3');
	  }
	  cleanresult($result2t);
	}
	else {
	  $tax1=getresult($result2,0,'taxe1');
	  $tax2=getresult($result2,0,'taxe2');
	  $tax3=getresult($result2,0,'taxe3');
	}
      }
      cleanresult($result2);

      $tot=$amount*$pquan;
      $tota=$tot*(1-($pdisc/100));
      $pattern= sprintf("%s , %s=%f ",$pattern,'amount',$amount);
      $pattern= sprintf("%s , %s=%.2f ",$pattern,'totamount',$tota);
      $pattern= sprintf("%s , %s=%f ",$pattern,'taxe1',$tax1);
      $pattern= sprintf("%s , %s=%f ",$pattern,'taxe2',$tax2);
      $pattern= sprintf("%s , %s=%f ",$pattern,'taxe3',$tax3);
      }
return $pattern;
}
//-------------------------------------------------------------------------
//Function check the group for REMOTE user
//-------------------------------------------------------------------------
function checkgrp($conn,$user,$chgrp)
{
    
$nbgrp=count($chgrp);
  for ($i=0;$i<$nbgrp;$i++) {
    $grp=$chgrp[$i];
    if ($user=='') 
    $pat2= "WHERE groupename = '$grp' and username='safejmp'";
    else
    $pat2= "WHERE groupename = '$grp' and username= '$user'";
    $result2=simplesearch($conn,$pat2,"groupe");
    $rows2=numrows($result2);
    cleanresult($result2);
    if ($rows2>=1) {
      return TRUE;
    }
  }
  return FALSE;
}
//-------------------------------------------------------------------------
//Function return a time
//-------------------------------------------------------------------------
function inttotime($value)
{
  if ($value<0) {
    $value=$value*-1;
    $neg=true;
  }
$heu1=$value/3600;
$heu=floor($heu1);
$min=($value/60)%60;
$sec=($value%3600)%60;
 if ($neg)
   $newval=sprintf("-%d:%02d:%02d",$heu,$min,$sec);
else
  $newval=sprintf("%d:%02d:%02d",$heu,$min,$sec);
return $newval;                                                             
}
//-------------------------------------------------------------------------
//Function take time and return a price
//-------------------------------------------------------------------------
function timetoprice($value,$poscurr,$currency,$value2)
{
  $long=strlen($value);
  $pos=strpos($value,":");
  if ($pos>0) {
    $heure=substr($value,0,$pos);
    $value=substr($value,$pos+1,$long-2);
    $long=strlen($value);
    $pos=strpos($value,":");
    if ($pos>0) {
      $min=substr($value,0,$pos);
      $sec=substr($value,$pos+1,$long-2);
      $prix=(($heure*3600)+($min*60)+$sec)/100;
      if ($value2) {
	$value=$value2;
	$long=strlen($value);
	$pos=strpos($value,":");
	if ($pos>0) {
	  $heure=substr($value,0,$pos);
	  $value=substr($value,$pos+1,$long-2);
	  $long=strlen($value);
	  $pos=strpos($value,":");
	  if ($pos>0) {
	    $min=substr($value,0,$pos);
	    $sec=substr($value,$pos+1,$long-2);
	    $prix2=(($heure*3600)+($min*60)+$sec)/100;
	    $prix=$prix+$prix2;
	  }
	}
      }
      if ($poscurr=="A") 
	$prix=sprintf("%.2f%s",$prix,$currency);
      else 
	$prix=sprintf("%s%.2f",$currency,$prix);
    }
  }
return $prix;
}
//-------------------------------------------------------------------------
//Function return a time
//-------------------------------------------------------------------------
function beforeinttotime($value)
{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");
switch($sqlbase) {
  case  'mysql' :
    $newval=inttotime($value);
    break;
  case 'postgresql' :
  default:
    $newval=$value;
    break;
  }
return $newval;                                                             
}
//-------------------------------------------------------------------------
//Function check the base int8 in SQl et timespan to postgresql
//-------------------------------------------------------------------------
function checktime($value,$sqlbase)
{
if ($sqlbase=="postgresql")
  $newval=$value;
else
  $newval=inttotime($value);
return $newval;
}
//-------------------------------------------------------------------------
//Function the good description
//-------------------------------------------------------------------------
function searchdesc($bigdes,$pos)
{
   $first=strpos($bigdes,"|");
   $lendes=strlen($bigdes);
   if ($first==0) 
     return $bigdes;
   if ($pos==1)
     $descrip=substr($bigdes,0,$first);

   $nextd=substr($bigdes,$first+1,$lendes-$first+1);
   $next=strpos($nextd,"|");
   $newlen=strlen($nextd);
   if ($next==0)
      if ($pos==2)
        $descrip=$nextd;
      else
        $descrip=substr($bigdes,0,$first);
   else
      if ($pos==2)
        $descrip=substr($nextd,0,$next);
      else
      if ($pos==3) {
         $nextd=substr($nextd,$next+1,$newlen-$next+1);
         $next=strpos($nextd,"|");
         $newlen=strlen($nextd);
         if ($next==0)
           $descrip=substr($nextd,0,$newlen);
         else
           $descrip=substr($nextd,0,$next);
      }
$lendescrip=strlen($descrip);
if ($lendescrip==0) 
  if ($first==0)
    $descrip=$bigdes;
  else
     $descrip=substr($bigdes,0,$first);
return $descrip;
}
//-------------------------------------------------------------------------
//Function the add include number (numinclude in info file)
//-------------------------------------------------------------------------
function addinclude($conn)
{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $res=mysql_db_query("$dbase","BEGIN");
    $res=mysql_db_query("$dbase","update info set numinclude=numinclude+1");
    $result=mysql_db_query("$dbase","SELECT numinclude FROM info");
    $res=mysql_db_query("$dbase","COMMIT");
    break;
  case 'postgresql' :
  default:
    $res=pg_exec($conn,"BEGIN;");
    $res=pg_exec($conn,"update info set numinclude=numinclude+1;");
    $result=pg_exec($conn,"SELECT numinclude FROM info;");
    $res=pg_exec($conn,"COMMIT;");
    break;
  }
if (!$result)
  fatale($conn,'addinclude');
return $result;
}
//-------------------------------------------------------------------------
//Function the add cd batch
//-------------------------------------------------------------------------
function addcdbatch($conn)
{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $res=mysql_db_query("$dbase","BEGIN");
    $res=mysql_db_query("$dbase","update info set batchcd=batchcd+1");
    $result=mysql_db_query("$dbase","SELECT batchcd FROM info");
    $res=mysql_db_query("$dbase","COMMIT");
    break;
  case 'postgresql' :
  default:
    $res=pg_exec($conn,"BEGIN;");
    $res=pg_exec($conn,"update info set batchcd=batchcd+1;");
    $result=pg_exec($conn,"SELECT batchcd FROM info;");
    $res=pg_exec($conn,"COMMIT;");
    break;
  }
if (!$result)
  fatale($conn,'addcdbatch');
return $result;
}
//-------------------------------------------------------------------------
//Function check this name of product is available
//-------------------------------------------------------------------------
function checkprod($conn,$pattern)
{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");
      $type='';
      $result2=simplesearch($conn,$pattern,"products");
      $rows2s=numrows($result2);
      if ($rows2s!=0) {
         $type="hispchprod2r";
      }
      else {
        $result2=simplesearch($conn,$pattern,"other");
        $rows2s=numrows($result2);
        if ($rows2s!=0) {
          $type="hispchprod2o";
        }
        else {
        $result2=simplesearch($conn,$pattern,"web");
        $rows2s=numrows($result2);
        if ($rows2s!=0) {
          $wtype=getresult($result2,0,'wtype');
          if ($wtype=='P')
            $type="hispchprod2p";
          else
            $type="hispchprod2w";
        }
        }
      }
return $type;
}
//-------------------------------------------------------------------------
//Function cleanname(replace space and & characters by _)
//-------------------------------------------------------------------------
function cleanname($value)
{
  $val=ereg_replace(" ","_",$value);
  $val=ereg_replace("&","_",$val);
  $val=ereg_replace("\+","_",$val);
  return $val;
}
//-------------------------------------------------------------------------
//Function prepare(replace space and & characters by _)
//-------------------------------------------------------------------------
function prepare($value)
{
  $val=ereg_replace(" ","%20",$value);
  $val1=ereg_replace("&","%=",$val);
  $val=ereg_replace("\+","%-",$val1);
  return $val;
}
//-------------------------------------------------------------------------
//Function replace(inverse prepare function)
//-------------------------------------------------------------------------
function replace($value)
{
  $val=ereg_replace("%20"," ",$value);
  $val=ereg_replace("%=","&",$val);
  $val=ereg_replace("%-","+",$val);
  $val=trim($val);
  $val=ltrim($val);
  return $val;
}
//-------------------------------------------------------------------------
//Function
//-------------------------------------------------------------------------
function interval($conn,$date,$oper,$day)
{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");
//echo ("oper=$oper, day=$day");
switch($sqlbase) {
  case  'mysql' :
   if ($day)
    switch($oper) {  
     case '+':
       $result=mysql_db_query("$dbase","SELECT date_add(date_add(date_add('$date', interval '1' MONTH), interval '-1' DAY), interval '2' HOUR)");
      break;
     case '-':
       $result=mysql_db_query("$dbase","SELECT date_add(date_add(date_add('$date', interval '-1' MONTH), interval '-1' DAY), interval '2' HOUR)");
      break;
     default:
       $result=mysql_db_query("$dbase","SELECT date_add(date_add('$date' , interval '-1' DAY), interval '2' HOUR)");
     }
  else
    switch($oper) {  
     case '+':
      $result=mysql_db_query("$dbase","SELECT date_add(date_add('$date', interval '1' month), interval '2' hour)");
      break;
     case '-':
      $result=mysql_db_query("$dbase","SELECT date_add(date_add('$date', interval '-1' month),interval '2' hour)");
      break;
     default:
      $result=mysql_db_query("$dbase","SELECT date_add('$date', interval '2' hour");
      }
  break;
  case 'postgresql' :
  default:
  if ($day)
    if ($oper)
      $result=pg_exec($conn,"SELECT date '$date' $oper interval '1 month' - interval '1 day' + interval '2 hour';");
    else
      $result=pg_exec($conn,"SELECT date '$date' - interval '1 day' + interval '2 hour';");
  else
    if ($oper)
      $result=pg_exec($conn,"SELECT date '$date' $oper interval '1 month' + interval '2 hour';");
    else
      $result=pg_exec($conn,"SELECT date '$date' + interval '2 hour';");
  }
  return $result;
}
//-------------------------------------------------------------------------
//Function calculinter
//-------------------------------------------------------------------------
function calculinter($conn,$dates,$small)
{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

  $newdate=$dates;
  if ($dates!=$small) {
  if ($dates<$small) {
  while ($newdate<=$small) {
//    $result=pg_exec($conn,"SELECT date '$newdate' + interval '1 month' + interval '2 hour';");
    $result=interval($conn,$newdate,"+",false);
    $newdate=getresult($result,0,0);
    $newdate=substr($newdate,0,10);

  }
    $result=interval($conn,$newdate,"-",false);
//    $result=pg_exec($conn,"SELECT date '$newdate' - interval '1 month' + interval '2 hour';");
    $newdate=getresult($result,0,0);
    $newdate=substr($newdate,0,10);
  }
  else {
    while ($newdate>$small) {
    $result=interval($conn,$newdate,"-",false);
//      $result=pg_exec($conn,"SELECT date '$newdate' - interval '1 month' + interval '2 hour';");
      $newdate=getresult($result,0,0);
      $newdate=substr($newdate,0,10);
    }
  }
    $result=interval($conn,$newdate,"+",false);
//    $result=pg_exec($conn,"SELECT date '$newdate' + interval '1 month' + interval '2 hour';");
    $newdate2=getresult($result,0,0);
    $newdate2=substr($newdate2,0,10);

    if ($newdate2<=$small) {
    $result=interval($conn,$newdate,"+",false);
//    $result=pg_exec($conn,"SELECT date '$newdate' + interval '1 month' + interval '2 hour';");
    $newdate=getresult($result,0,0);
    $newdate=substr($newdate,0,10);
    $newdate2=$newdate;
    }

  }
  else
    $newdate=$small;

  return $newdate;
}
//-------------------------------------------------------------------------
//Function calculinterfin
//-------------------------------------------------------------------------
function calculinterfin($conn,$dater,$jourc)
{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

  $result=interval($conn,$dater,"+",true);
//  $result=pg_exec($conn,"SELECT date '$dater' + interval '1 month' - interval '1 day' + interval '2 hour';");
  $newdate=getresult($result,0,0);
  $lastpers=substr($newdate,0,10);

if ($jourc!='01') {
$lastpers=verifinter($conn,$lastpers,$jourc);
  $result=interval($conn,$lastpers,"",true);
//  $result=pg_exec($conn,"SELECT date '$lastpers' - interval '1 day';");

  $lastpers=getresult($result,0,0);
  $lastpers=substr($lastpers,0,10);
}
  return $lastpers;
}
//-------------------------------------------------------------------------
//Function calculinter
//-------------------------------------------------------------------------
function calculinter1($conn,$date)
{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

  $result=interval($conn,$date,"-",false);
//  $result=pg_exec($conn,"SELECT date '$date' - interval '1 month' + interval '2 hour';");
  $newdate=getresult($result,0,0);
  $newdate=substr($newdate,0,10);
  return $newdate;
}
//-------------------------------------------------------------------------
//Function calculinter
//-------------------------------------------------------------------------
function verifinter($conn,$lastpere,$jourc)
{
$an=substr($lastpere,0,4);
$jour=substr($lastpere,8,2);
$mois=substr($lastpere,5,2);
switch($mois) {
    case 1:
    case 3:
    case 5:
    case 7:
    case 8:
    case 10:
    case 12:
            if ($jourc> $jour)
              $lastpere=sprintf("%s-%s-%s",$an,$mois,$jourc);
            break;

    case 2:
            if ($jourc> $jour) {
              if (($jourc==31) or ($jourc==30) or ($jourc==29)) {
                $nban=$an/4;
                if (is_integer($nban)) {
                  $jourc1=29;
		  }
	        else
                  $jourc1=28;
                }
              else
                $jourc1=$jourc;
              $lastpere=sprintf("%s-%s-%s",$an,$mois,$jourc1);
            }
            break;
    case 4:
    case 6:
    case 9:
    case 11:
            if ($jourc > $jour) {
              if ($jourc==31)
                $jourc1=30;
              else
                $jourc1=$jourc;
              $lastpere=sprintf("%s-%s-%s",$an,$mois,$jourc1);
            }
            break;
}
  return $lastpere;
}
//-------------------------------------------------------------------------
//Function inhour
//-------------------------------------------------------------------------
function inhour($total)
{
  $blanc=strpos($total," ");
  $newlen=strlen($total);
  if ($blanc>0) {
     $jour=substr($total,0,$blanc);
     $reste=substr($total,$blanc+1,$newlen-$blanc+1);
     $blanc=strpos($reste," ");
     if ($blanc>0) {
     $newlen=strlen($reste);
     $reste=substr($reste,$blanc+1,$newlen-$blanc+1);
     }
     $point=strpos($reste,":");
     $newlen=strlen($reste);
     $heure=substr($reste,0,$point);
     $reste=substr($reste,$point,$newlen-$point);
     $heure=($jour*24)+$heure;
     $total=sprintf("%s%s",$heure,$reste);
     
     }

  return $total;

}
//-------------------------------------------------------------------------
//Function printbyte
//-------------------------------------------------------------------------
function printbyte($nbrbyte)
{
  $format="Bytes";
  if ($nbrbyte>1024*10) {
    $nbrbyte=sprintf("%.2f",$nbrbyte/1024);
    $format="KB";
    if ($nbrbyte>1024*10) {
      $nbrbyte=sprintf("%.2f",$nbrbyte/1024);
      $format="MB";
      if ($nbrbyte>1024*10) {
	$nbrbyte=sprintf("%.2f",$nbrbyte/1024);
	$format="GB";
	if ($nbrbyte>1024*10) {
	  $nbrbyte=sprintf("%.2f",$nbrbyte/1024);
	  $format="TB";
	}
      }
    }
  }
  $byte=sprintf("%.2f %s",$nbrbyte,$format);
  return $byte;
}
//-------------------------------------------------------------------------
//Function valideuser(Check userid and billedto not contain ' ou char < ' ')
//-------------------------------------------------------------------------
function valideuser($userid)
{
  $len=strlen($userid);
  $valide=true;
  for ($i=0;$i<$len;$i++) {
    $onechar=substr($userid,$i,1);
    if (($onechar<' ') or ($onechar=="'"))
      $valide=false;
  }
  return $valide;
}
//-------------------------------------------------------------------------
//Function valideuser(Check userid and billedto not contain ' ou char < ' ')
//-------------------------------------------------------------------------
function specialmysql($code,$patt)
{
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");
// $sqlbase="postgresql";
switch($sqlbase) {
  case  'mysql' :
    switch($code) {
    case  1 :
      $patternsu=ereg_replace("WHERE ","",$patt);
      $pattern=sprintf("userreg.billedto=userbill.userid and userbill.%s ",$patternsu);
      break;
    case  2 :
      $patternsu=ereg_replace("WHERE ","",$patt);
      $pattern=sprintf("contract.billedto=userbill.userid and userbill.%s ",$patternsu);
      break;
    case  3 :
      $patternsu=ereg_replace("WHERE ","",$patt);
      $pattern=sprintf("contract.billedto=userreg.userid and contract.%s ",$patternsu);
      break;
    }
    break;
  case 'postgresql' :
  default:
    switch($code) {
    case  1 :
    case  2 :
     $pattern=sprintf("billedto in (select userid from userbill %s )",$patt);
    break;
    case  3 :
     $pattern=sprintf("billedto in (select billedto from contract %s )",$patt);
    break;
    }
}
  return $pattern;
}
//--------------------------------------------------------------------------
//functions to test is a good retailer
//--------------------------------------------------------------------------
function testretail($conn,$billedto,$remuser)
{
  $affiche=0;                         
  $chgrp=array('retailer');
  if (checkgrp($conn,$remuser,$chgrp)) {
    $newpat = "WHERE userid = '$billedto'";
    $result=simplesearch($conn,$newpat,"userbill");
    $nrows=numrows($result);
    if ($nrows==1) {
      $revend=getresult($result,0,'revend');
      if ($revend!=$remuser)
	$affiche=1;
    }
    else {
      $affiche=2;
    }
  }
  return $affiche;
}
//--------------------------------------------------------------------------
//functions to test is a good retailer
//--------------------------------------------------------------------------
function badretail($affiche,$erreur1,$erreur2)
{
  echo ("<BR>\n");
  echo ("<BR>\n");
  echo ("<BR>\n");
  echo ("<CENTER><FONT SIZE=+2>\n");
  if ($affiche==1)
    echo ("$erreur1\n");
  else
    echo ("$erreur2\n");
  echo ("</FONT>\n");
  echo ("</CENTER>\n");
  echo ("<BR>\n");
  echo ("<BR>\n");
  echo ("<BR>\n");

}
//--------------------------------------------------------------------------
//trouve l'escompte ou la commission pour ce revend avec ce produit
//--------------------------------------------------------------------------
function trouvedisc($conn,$product,$revend,$type)
{
  $discount=0;

  $newpat = "WHERE promotion = '$product'";
  $result=simplesearch($conn,$newpat,"promotion");
  $nrows=numrows($result);
  if ($nrows>0) {
    $product=getresult($result,0,'product');
  }
  $newpat = "WHERE prodname = '$product'";
  $result=simplesearch($conn,$newpat,"products");
  $nrows=numrows($result);
  if ($nrows==0) {
    $newpat = "WHERE packname = '$product'";
    $result=simplesearch($conn,$newpat,"packages");
    $nrows=numrows($result);
  }
  if ($nrows>0) {
    $producttype=getresult($result,0,'producttype');
    $newpat = "WHERE prodtype = '$producttype' and name='$revend' and type='$type'";
    $resultd=simplesearch($conn,$newpat,"disc_comm");
    $nrowsd=numrows($resultd);
    if ($nrowsd==1) {
      $discount=getresult($resultd,0,'pourcent');
    }
  }

  return $discount;
}


//--------------------------------------------------------------------------
// transforme un montant avec le "currency" dans htmlequi.conf
//--------------------------------------------------------------------------
function place_curr($gtot,$poscurr,$currency)
{
    if ($poscurr=="A") {
      $gtote=sprintf("%.2f %s",$gtot,$currency);
      $gtot=sprintf("%.2f %s",$gtot,$currency);
      }
    else {
      $gtote=sprintf("%s %.2f",$currency,$gtot);
      $gtot=sprintf("'%s '%.2f",$currency,$gtot);
    }
  return $gtot;

}
//--------------------------------------------------------------------------
//trouve l'escompte ou la commission pour ce revend avec ce produit
//--------------------------------------------------------------------------
function cherchetax($conn,$lang,$province,$pos,$mont)
{
  $base=getenv("base");
  include ("$base/conf/htmlequi.conf");
  // echo ("lang=$lang,prov=$province,pos=$pos");
  $patt="where province='$province'";
  $result=simplesearch($conn,$patt,"taxes");
  $nrows=numrows($result);
  if ($nrows==1) {
    switch($pos) {
    case  1 :
    if (($lang=='English') or ($lang=='eng'))
      $comm=getresult($result,0,'t1e');
    else
      $comm=getresult($result,0,'t1f');
    break;
    case  2 :
    if (($lang=='English') or ($lang=='eng'))
      $comm=getresult($result,0,'t2e');
    else
      $comm=getresult($result,0,'t2f');
    if ((!$comm) and ($mont))
      $comm=$deftax2;
    break;
    case  3 :
    if (($lang=='English') or ($lang=='eng'))
      $comm=getresult($result,0,'t3e');
    else
      $comm=getresult($result,0,'t3f');
    break;
    }

  }
  else {
    switch($pos) {
    case  1 :
      $comm=$deftax1;
      break;
    case  2 :
      $comm=$deftax2;
      break;
    case  3 :
      $comm=$deftax3;
      break;
    }
  }    

  return $comm;

}

//--------------------------------------------------------------------------
//trouve la categorie a partir d'un produit
//--------------------------------------------------------------------------
function trouvecat($conn,$product,$type)
{
  if ($type=='') {
    $cat_type='';
    $base=getenv("base");
    $patt="where packname='$product'";
    $result=simplesearch($conn,$patt,"packages");
    $nrows=numrows($result);
    if ($nrows>0) {
      $product=getresult($result,0,'prodname');
    }
    $patt="where prodname='$product'";
    $result=simplesearch($conn,$patt,"products");
    $nrows=numrows($result);
    if ($nrows==0) {
      $result=simplesearch($conn,$patt,"other");
      $nrows=numrows($result);
    }
  }
  if (($nrows==1) or ($type!='')) {
    if ($type)
      $producttype=$type;
    else
      $producttype=getresult($result,0,'producttype');
    $patt="where prodtype='$producttype'";
    $result=simplesearch($conn,$patt,"product_type");
    $nrows=numrows($result);
    if ($nrows==1) {
      $cat_type=getresult($result,0,'cat_type');
    }
  }
    else {
      $patt="where prodname='$product' and billedto is null";
      $result=simplesearch($conn,$patt,"web");
      $nrows=numrows($result);
      if ($nrows==1)
	$cat_type="HEB";
    }
  return $cat_type;

}

//--------------------------------------------------------------------------
//convertir .5 en .51 pour les taxes
//--------------------------------------------------------------------------
function arrondir($tax,$numcnt)
{

  $point=strpos($tax,".");
  $long=strlen($tax);
  if ($long-$point-1>2) {
    if (substr($tax,$long-1,1)==5) {
      $gtax=sprintf("%.2f",$tax);
      $tax.="1";
      $gtax1=sprintf("%.2f",$tax);
      //      if ($gtax<>$gtax1)
      //	passthru ("echo numcnt=$numcnt tax=$tax gtax1=$gtax1>> /tmp/didi",$num);
    }
  }

  return $tax;
  
}

//--------------------------------------------------------------------------
//Begin and lock database
//--------------------------------------------------------------------------
function beginlock($conn,$namefile)

{
  //    echo ("pat=$pattern");
  //  echo ("name=$namefile<BR>");
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","BEGIN");
    $result=mysql_db_query("$dbase","lock table $namefile write");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"BEGIN;");
    $result=pg_exec($conn,"lock table $namefile;");
    break;
  }

}
//--------------------------------------------------------------------------
//commitdb
//--------------------------------------------------------------------------
function commitdb($conn)

{
  //    echo ("pat=$pattern");
  //  echo ("name=$namefile<BR>");
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $result=mysql_db_query("$dbase","commit");
    break;
  case 'postgresql' :
  default:
    $result=pg_exec($conn,"commit;");
    break;
  }

if (!$result)
  fatale($conn,'commitdb');
return $result;
}
//--------------------------------------------------------------------------
//func_encrypt
//--------------------------------------------------------------------------
function func_encrypt($conn,$crcard,$code_crypt)

{
  //    echo ("pat=$pattern");
  //  echo ("name=$namefile<BR>");
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

switch($sqlbase) {
  case  'mysql' :
    $strloc=sprintf("crcard = aes_encrypt('%s','$code_crypt')",$crcard);
    break;
  case 'postgresql' :
  default:
    $strloc=sprintf("crcard = encrypt('%s','$code_crypt','aes')",$crcard);
    break;
  }
return $strloc;
}
//--------------------------------------------------------------------------
//func_decrypt
//--------------------------------------------------------------------------
function func_decrypt($conn,$patt,$code_crypt,$namefile)

{
  //    echo ("pat=$patt");
  //  echo ("name=$namefile<BR>");
$sqlbase=getenv("sqlbase");
$dbase=getenv("dbase");

//$patt="where userid='$userid'";
switch($sqlbase) {
  case  'mysql' :
    if ($namefile)
    $result2=diffsearch($conn,$patt,$namefile,"aes_decrypt(crcard,'$code_crypt')");
else
    $result2=diffsearch($conn,$patt,'userbill',"aes_decrypt(crcard,'$code_crypt')");
    break;
  case 'postgresql' :
  default:
    if ($namefile)
    $result2=diffsearch($conn,$patt,$namefile,"decrypt(crcard,'$code_crypt','aes')");
else
    $result2=diffsearch($conn,$patt,'userbill',"decrypt(crcard,'$code_crypt','aes')");
    break;
  }
$crcard=getresult($result2,0,0);
return $crcard;
}
//--------------------------------------------------------------------------
//func write in customer log.
//--------------------------------------------------------------------------
function write_log_client($base,$message,$userid,$crcard,$total)
 
{
  if (($crcard) and ($crcard!='Unknown')) {
    $long=strlen($crcard);
    if ($long>0) {
      $deb=substr($crcard,0,4);
      $fin=substr($crcard,$long-4,4);
      $val2="XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";
      $val2=substr($val2,0,$long-8);
      $crcard=sprintf("%s%s%s",$deb,$val2,$fin);
    }
  }
  $REMOTE_ADDR=getenv("REMOTE_ADDR");
   $today=date("Ymd");
   $namei=sprintf("%s/data_cust/cust-%s.jrl",$base,$today);
   $fp=fopen("/tmp/cust-log.lock","w");
   if (flock($fp, LOCK_EX)) { // pose un verrou exclusif/do an exclusive lock
     ftruncate($fp, 0);     // effacement du contenu/Write something here
     $pid=getmypid();
     fwrite($fp, $pid);
     $fpi=fopen($namei,"a+");
     $time=date("H:i:s");
     $exitp=sprintf("%s %s %s %s %s %s\n",$time,$REMOTE_ADDR,$userid,$message,$crcard,$total);
     fwrite($fpi,$exitp);
     fclose($fpi);
     flock($fp, LOCK_UN);   // libère le verrou/release the lock
   } 
   /*
   else {
     echo "Couldn't lock the file !";
   }
   */
   fclose($fp);

}
//--------------------------------------------------------------------------
//Calculate outstanding amount from previous unpaid invoices
//--------------------------------------------------------------------------

function calc_outstanding($base, $conn, $userid, $invoice, $until, $type,$datenewtaxe,$num_facl,$liste)
{
  if ($type==1)
    $where = "WHERE billedto = '$userid' ";
  //    $where = "WHERE billedto = '$userid' and (canceled<>'Y' or canceled is null)";
  else
    $where = "WHERE linkto = '$userid' ";
  //    $where = "WHERE linkto = '$userid' and (canceled<>'Y' or canceled is null)";
# Uncommenting the next line disables calculating outstanding credit
#    $where .= " AND (okpaid<> 'Y' or okpaid is  null)";
    if ($type==1)
      $where .= " AND (datestart <= '$until' or datestart is null) and numcnt<$invoice ";
    else
      $where .= " AND invdate <= '$until' and numcnt<$invoice ";
    $where .= " ORDER by numcnt";
    if ($type==1)
   $contracts = simplesearch($conn, $where, 'contract');
    else {
   $contracts = simplesearch($conn, $where, 'conlink');
    $typeinv='LINK';
    }
    $outstd = 0;
    $xx=numrows($contracts);
    for($c = 0; $c < numrows($contracts); $c++) {
        $numcredit=getresult($contracts, $c, 'numcredit');
        $canceled=getresult($contracts, $c, 'canceled');
        $okpaid=getresult($contracts, $c, 'okpaid');
	if (($canceled=='Y') and (!$numcredit))
	  # skip facture annule.
	  continue;

        $numinv=getresult($contracts, $c, 'numcnt');
	if($numinv == $invoice) {
            # Skip contract being displayed
            continue;
        }
        $numcntl=getresult($contracts, $c, 'numcntl');
        $paid=getresult($contracts, $c, 'paid');

        if (!$numcntl)
          $numcntl=0;

        if (($numcntl != 0) and ($paid)) {
            # Skip contract being displayed
	  continue;
        }

        $pattern2 = "WHERE numcnt = $numinv"; 
        $pattern2i = "WHERE numcnt = $numinv order by invlink"; 
        $resulti=simplesearch($conn, $pattern2i, "invoiced");
	$rowsi=numrows($resulti);

	$gtot=0;
	$gtax1=0;
	$gtax2=0;
	$gtax3=0;
	$nbinv=0;
	include (direcname("$base","updtax.php"));
	$resulti=simplesearch($conn,$pattern2i,"logvoip");
	$rowsi=numrows($resulti);
	include (direcname("$base","updtax.php"));


	$owt1=$gtax1;
	$owt2=$gtax2;
	$owt3=$gtax3;
        cleanresult($resulti);
        $sumline = $sumline + 1;
        $resulti = simplesearch($conn, $pattern2, "collected");
        $rowsi = numrows($resulti);
        $coll = 0;
        $owing = 0;
        for($j = 0; $j < $rowsi; $j++) {
            $totam = getresult($resulti, $j, 'totamount');
            $coll  = $coll + $totam;
        }
        $owing = $gtot - $coll;
        cleanresult($resulti);
	if (($liste==1) and ($owing!=0) and ($okpaid!='Y')) {
	  $listenum.=$numinv;
	  $listenum.=',';
	}
    $outstd  = $outstd + $owing;

    }
    if ($liste==1)
    return $listenum;
    else
    return $outstd;
}
//--------------------------------------------------------------------------
//Add prepaid time in cptinfo
// interface  1= client  2=support
//--------------------------------------------------------------------------
function addprepaid($conn, $base, $product, $userid, $userid_sec, $mess,$interface,$remuser)
{
  if ($interface==2)
    $origin=$remuser;
  else
    $origin='CLIENT';
  $sauve1=false;
  if (($product) and ($userid)) {
    if (!$userid_sec)
      $userid_sec=$userid;
    $pattern = "WHERE prodname='$product' and prepaid='Y'";
    $resulto=simplesearch($conn,$pattern,"other");
    $rowso=numrows($resulto);
    $tprepaid=0;
   if ($rowso==1) {
      $tprepaid=getresult($resulto,0,'tprepaid');
      $tprepaid_org=$tprepaid;
    }
    if ($tprepaid>0) {

      $pattern = "WHERE userid='$userid_sec'";
      $resultu=simplesearch($conn,$pattern,"userbill");
      $rowsu=numrows($resultu);
      if ($rowsu==1) {
	$curinvseq=getresult($resultu,0,'curinvseq');
	if ($curinvseq) {
	$pattern = "WHERE numcnt=$curinvseq and cpttype like '%VP%' order by ordernum desc";
	$resultc=simplesearch($conn,$pattern,"cptinfo");
	$rowsc=numrows($resultc);
	$i=0;
	$sauve=false;
	while ($rowsc>$i) {
	  $cpttype=getresult($resultc,$i,'cpttype');
	  $cptname=getresult($resultc,$i,'cptname');
	  $presetvalue=getresult($resultc,$i,'presetvalue');
	  $available=getresult($resultc,$i,'available');
	  $ordernum=getresult($resultc,$i,'ordernum');
	  $pattern2="numcnt=$curinvseq and ordernum=$ordernum";
	  $pos=strpos($cpttype,'M');
	  if ($pos>0) {
	    if (($available<$presetvalue) or ($i+1==$rowsc)) {
	      if ($available+$tprepaid<=$presetvalue) {
		$tprepaid=0;
		$available=$availble+$tprepaid;
	      }
	      else {
		if ($i+1==$rowsc) {
		  $add_prepaid=$tprepaid;
		  $available=$available+$tprepaid;
		  if ($available>$presetvalue)
		    $presetvalue=$available;
		}
		else {
		  $add_prepaid=($presetvalue-$available);
		  $tprepaid=$tprepaid-($presetvalue-$available);
		  $available=$presetvalue;
		}
	      }
	      $sauve=true;
	      //sauve
	    }
	  }
	  else { // pos=0
	    $available=$available+$tprepaid;
	    $add_prepaid=$tprepaid;
	    $tprepaid=0;
	    if ($available>$presetvalue) 
	      $presetvalue=$available;
	    $sauve=true;
	    //sauve
	  }
	  if ($sauve) {
	    if (!$sauve1) {
	      $imp_tprepaid=$tprepaid_org/100;
	      $messerr="$mess OK $imp_tprepaid $  user:$userid_sec";
		if ($interface==1) {
		  write_log_client($base,$messerr,$userid);
		}
		else
	    echo ("<CENTER><font=+1>$mess OK $imp_tprepaid $  user:$userid_sec</font></center>");
	    }
	    $sauve1=true;
	    $pattern="available=$available,presetvalue=$presetvalue";
	    $result2=cptupdate($conn,$pattern2,$pattern,"cptinfo");
	    $sauve=false;
	    $today=date("Y-m-d H:i:s");
            $nbm=inttotime($add_prepaid);
            $pattern="30,'$cptname','$today','$today','$userid_sec','$userid_sec','void',1,'$nbm','$available',0,0,0,0,$curinvseq,0,'void','void',2";
	    $result=simplewrite($conn,$pattern,"transaclog");
	    $datecomm=date("Y-m-d H:i:s");
	    $typec="2";
	    $add_prepaid=$add_prepaid/100;
	    $newcomm="$mess $add_prepaid $ cpt: $cptname";
	    $pattern = "'$userid','$datecomm','$origin','$newcomm','$typec'";
	    $result2=simplewrite($conn,$pattern,"comments");
	    $typec='U';
	    $pattern = "'$userid','$datecomm','$origin','$newcomm','$typec'";
	    $result2=simplewrite($conn,$pattern,"comments");
	    cleanresult($result2);
	  }
	  $i++;
	} // while
	}
      }
    }
  }
	if (!$sauve1) {
	    $imp_tprepaid=$tprepaid_org/100;
	  if ($interface==1) {
	    $messerr="$mess ERROR $imp_tprepaid $  user:$userid_sec";
	    write_log_client($base,$messerr,$userid);
	  }
	  else {
	    echo ("<CENTER><font=+1>$mess ERROR $imp_tprepaid $  user:$userid_sec</font></center>");
	  }
	    $messerr="ERROR $mess $imp_tprepaid $ ";
	    $datecomm=date("Y-m-d H:i:s");
	    $typec="2";
	    $newcomm="$messerr  cpt: unknown";
	    $pattern = "'$userid','$datecomm','$origin','$newcomm','$typec'";
	    $typec='U';
	    $pattern = "'$userid','$datecomm','$origin','$newcomm','$typec'";
	    $result2=simplewrite($conn,$pattern,"comments");
	    cleanresult($result2);
	}
}
//--------------------------------------------------------------------------
//Add prepaid time in cptinfo
// interface  1= client  2=support
//--------------------------------------------------------------------------
function check_addprepaid($conn, $base, $numcnt, $product, $userid, $userid_sec, $mess,$interface,$remuser)
{
  if (!$userid) {
    $pattern2 = "WHERE numcnt = $numcnt";
    $resultcont2=simplesearch($conn,$pattern2,"contract");
    $rowscon2=numrows($resultcont2);
    if ($rowscon2>0) {
      $userid=getresult($resultcont2,0,'billedto');
    }
  }
  $pattern2 = "WHERE numcnt = $numcnt";
  $resultcon2=simplesearch($conn,$pattern2,"invoiced");
  $rowscon2=numrows($resultcon2);
  //                                                                    
  for ($xx=0;$xx<$rowscon2;$xx++) {
    $product=getresult($resultcon2,$xx,'product');
    $quantity=getresult($resultcon2,$xx,'quantity');
    $pattern2 = "WHERE prodname= '$product' and prepaid='Y'";
    $resultp=simplesearch($conn,$pattern2,"other");
    $rowsp=numrows($resultp);
    if ($rowsp==1) {
      $userid_sec=getresult($resultcont2,0,'billedto');
      $comm_voip="start";
      $comment_voip="$hretcoll $remuser";
      $comment_voip=ereg_replace("'","''",$comment_voip);
      include (direcname("$base","updvoip.php"));
      $j=0;
      while ($j<$quantity) {
	addprepaid($conn,$base,$product,$userid,$userid_sec,$mess,$interface,$remuser);
	$j++;
      }
    }
  }

}
//--------------------------------------------------------------------------
//Check counter prepaid in cptinfo
//--------------------------------------------------------------------------
function cptinfo_prepaid($conn, $userid) {
 $pattern = "WHERE userid = '$userid'";
  $resultb=simplesearch($conn,$pattern,"userbill");
  $rowsb=numrows($resultb);
  $cptvoip=false;
  if ($rowsb>=1) {
    $curinvseq=getresult($resultb,0,'curinvseq');
    if ($curinvseq) {
      $patternb = "WHERE numcnt=$curinvseq order by ordernum";
      $resultc=simplesearch($conn,$patternb,"cptinfo");
      $rowsc=numrows($resultc);
      for ($y=0;$y<$rowsc;$y++) {
	$cptname=getresult($resultc,$y,'cptname');
	$cpttype=getresult($resultc,$y,'cpttype');
	$pos=strpos($cpttype,'V');
	$first=substr($cpttype,0,1);
	if (($pos>0) or ($first=='V')) {
	  $pos2=strpos($cpttype,'P');
	  if ($pos2>0)
	    $cptvoip=true;
        }
      }
    }
  }
  return $cptvoip;
}
//--------------------------------------------------------------------------
//Return time  prepaid available  in cptinfo
//--------------------------------------------------------------------------
function cptinfo_prepaid_avai($conn, $userid)
{
  $pattern = "WHERE userid = '$userid'";
  $avai=0;
  if ($userid) {
    $result=simplesearch($conn,$pattern,"userbill");
    $rows=numrows($result);
    if ($rows>=1) {
      $curinvseq=getresult($result,0,'curinvseq');
      if ($curinvseq) {
	$patternb = "WHERE numcnt=$curinvseq order by ordernum";
	$resultc=simplesearch($conn,$patternb,"cptinfo");
      }
    }
    $rowsc=numrows($resultc);
    $avail=0;

    for ($y=0;$y<$rowsc;$y++) {
      $cptname=getresult($resultc,$y,'cptname');
      $cpttype=getresult($resultc,$y,'cpttype');
      $available=getresult($resultc,$y,'available');
      $pos=strpos($cpttype,'V');
      $first=substr($cpttype,0,1);
      if (($pos>0) or ($first=='V')) {
	$pos2=strpos($cpttype,'P');
	if ($pos2>0)
	  $avail=$available+$avail;
      }
    }
    $mavail=$avail/100;
    if ($poscurr=="A") {
      $avai=sprintf("%.2f%s",$mavail,$currency);
    }
    else {
      $avai=sprintf("%s%.2f",$currency,$mavail);
    }

  }
  return $avai;
}
//--------------------------------------------------------------------------
//Check valid current contrat and counter in cptinfo
//--------------------------------------------------------------------------
function check_contratok($conn, $userid) {
  $today=date("Y-m-d");
  $pattern = "WHERE userid = '$userid'";
  $resultb=simplesearch($conn,$pattern,"userbill");
  $rowsb=numrows($resultb);
  $contratok=false;
  if ($rowsb>=1) {
    $curinvseq=getresult($resultb,0,'curinvseq');
    if ($curinvseq) {
      $patternb = "WHERE numcnt=$curinvseq";
      $resultc=simplesearch($conn,$patternb,"cptinfo");
      $rowsc=numrows($resultc);
      $resultc=simplesearch($conn,$patternb,"contract");
      $rowscon=numrows($resultc);
      if ($rowscon>0) {
	$datestop=getresult($resultc,0,'datestop');
	$product=getresult($resultc,0,'product');
	$pattern = "where prodname='$product' ORDER by prodapp";
	$resultprw=simplesearch($conn,$pattern,"prod_app");
	$rowsprw=numrows($resultprw);
      }
      if (($datestop>=$today) and ($rowsc>0) and ($rowsprw>0))
	$contratok=true;
    }
  }
  return $contratok;
}
//--------------------------------------------------------------------------
//Check max for adjunct product
//--------------------------------------------------------------------------
function sum_adjunct($conn, $userid) {
  $today=date("Y-m-d");
  $pattern = "WHERE userid = '$userid'";
  $resultb=simplesearch($conn,$pattern,"userbill");
  $rowsb=numrows($resultb);
  $sum=100000;
  if ($rowsb>=1) {
    $curinvseq=getresult($resultb,0,'curinvseq');
    if ($curinvseq) {
      $patternb = "WHERE numcnt=$curinvseq";
      $resultc=simplesearch($conn,$patternb,"cptinfo");
      $rowsc=numrows($resultc);
      if ($rowsc>0) {
	$last=getresult($resultc,0,'last');
	$pattern = "where userid='$userid' and typec='U' and datecomm>'$last'";
	$sum=calculsum($conn,"cost","comments",$pattern);
      }
    }
  }
  return $sum;
}
//--------------------------------------------------------------------------
//Find current product
//--------------------------------------------------------------------------
function find_curprod($conn, $userid) {
  $product='';
  $pattern = "WHERE userid = '$userid'";
  $resultb=simplesearch($conn,$pattern,"userbill");
  $rowsb=numrows($resultb);
  if ($rowsb>=1) {
    $curinvseq=getresult($resultb,0,'curinvseq');
    if ($curinvseq) {
      $patternb = "WHERE numcnt=$curinvseq";
      $resultc=simplesearch($conn,$patternb,"contract");
      $rowsc=numrows($resultc);
      if ($rowsc>0) {
	$product=getresult($resultc,0,'product');
      }
    }
  }
  return $product;
}
//--------------------------------------------------------------------------
//Add bandwidth in cptinfo
// interface  1= client  2=support
//--------------------------------------------------------------------------
function addbandw($conn, $base, $product, $userid, $userid_sec, $mess,$interface,$remuser)
{
  if ($interface==2)
    $origin=$remuser;
  else
    $origin='CLIENT';
  $sauve=false;
  if (($product) and ($userid)) {
    if (!$userid_sec)
      $userid_sec=$userid;
    $pattern = "WHERE userid='$userid_sec'";
    $resultu=simplesearch($conn,$pattern,"userbill");
    $rowsu=numrows($resultu);
    if ($rowsu==1) {
      $curinvseq=getresult($resultu,0,'curinvseq');
      if ($curinvseq) {
	$pattern = "WHERE numcnt=$curinvseq ";
	$resultc=simplesearch($conn,$pattern,"cptinfo");
	$rowsc=numrows($resultc);
	if ($rowsc>0) {
	  $last=getresult($resultc,0,'last');
	  $order=$rowsc;
	  $sauve=true;
	  // ajout compteur
	}
	else {
	  // pas de compteur cptinfo
	}
      }
      else {
	// pas de contrat
      }
    }
    else {
    // pas d'usager
    }
  }
  if ($sauve) {

    $pattern2 = "WHERE prodname= '$product' and prodtype='B'";
    $resultp=simplesearch($conn,$pattern2,"products");
    $rowsp=numrows($resultp);
    $iii=1;
    $tbytestot=0;
    while ($iii<11) {
      $cpt=sprintf("%s%d",'cpnts',$iii);
      $cpnts=getresult($resultp,0,$cpt);
      $pattern = "WHERE cptname='$cpnts'";
      $resultco=simplesearch($conn,$pattern,"counters");
      $rowsco=numrows($resultco);
      if ($rowsco==1) {
	$maxsession=getresult($resultco,0,'maxsession');
	if (!$maxsession)
	  $maxsession=0;
	$cptper=getresult($resultco,0,'cptper');
	$allowed=getresult($resultco,0,'allowed');
	$hunt=getresult($resultco,0,'hunt');
	$maxbytes=getresult($resultco,0,'maxbytes');
	if (!$maxbytes)
	  $maxbytes=0;
	$bytesin=getresult($resultco,0,'bytesin');
	$bytesout=getresult($resultco,0,'bytesout');
	$bytestot=getresult($resultco,0,'bytestot');
	$band_coef=getresult($resultco,0,'band_coef');
	if (!$bytestot)
	  $bytestot=0;
	$tbytestot=$tbytestot+$bytestot;
	$pos=strpos($cptper,'P');
	if ($pos>0) {
	  $allowed=$allowed+$avai;
	  $avai=0;
	}
	$acarin=$bytesin*1024*1024;
	$acarout=$bytesout*1024*1024;
	$order++;
	$sortie="$curinvseq,$order,'$cpnts',$allowed,$allowed,'$last',$maxsession,'$cptper',$maxbytes,$bytesin,$bytesout,$acarin,$acarout,'$hunt',$bytestot,0,$band_coef";
//	echo ("<BR>sortie=$sortie");
	$result=simplewrite($conn,$sortie,'cptinfo');
      }
      $iii++;
    }

  $sauve=false;
  $today=date("Y-m-d H:i:s");
    $imp_tprepaid=$tbytestot/1024;
    $imp_tprepaid=sprintf("%.2f",$imp_tprepaid);
    $messerr="$mess OK $imp_tprepaid GB  user:$userid_sec prod:$product";
    $messe=ereg_replace("''","'",$mess);
    if ($interface==1) {
      write_log_client($base,$messerr,$userid);
    }
    else
      echo ("<CENTER><font=+1>$messe OK $imp_tprepaid GB  user:$userid_sec</font></center>");
  /*
  $nbm=inttotime($add_prepaid);
  $pattern="30,'$cptname','$today','$today','$userid_sec','$userid_sec','void',1,'$nbm','$available',0,0,0,0,$curinvseq,0,'void','void',2";
  $result=simplewrite($conn,$pattern,"transaclog");
  */
    $price_prod=0;
    $pattern2 = "WHERE prodname= '$product'";
    $resultp=simplesearch($conn,$pattern2,"prices");
    $rowsp=numrows($resultp);
    if ($rowsp==1) {
	$price_prod=getresult($resultp,0,'cost');
    }
  $datecomm=date("Y-m-d H:i:s");
  $typec="2";
  $add_prepaid=$tbytestot/1024;
  $add_prepaid=sprintf("%.2f",$add_prepaid);
  $newcomm="$mess $add_prepaid GB prod: $product $price_prod$";
  $pattern = "'$userid','$datecomm','$origin','$newcomm','$typec','$price_prod'";
  $result2=simplewrite($conn,$pattern,"comments");
  $typec='U';
  $pattern = "'$userid','$datecomm','$origin','$newcomm','$typec','$price_prod'";
  $result2=simplewrite($conn,$pattern,"comments");
  cleanresult($result2);
  }
  else {
	    $imp_tprepaid=$tprepaid_org/100;
	  if ($interface==1) {
	    $messe=ereg_replace("''","'",$mess);
	    $messerr="$mess ERROR user:$userid_sec prod: $product";
	    write_log_client($base,$messerr,$userid);
	  }
	  else {
	    echo ("<CENTER><font=+1>$messe ERROR user:$userid_sec prod:$product</font></center>");
	  }
	    $messerr="ERROR $mess prod:$product ";
	    $datecomm=date("Y-m-d H:i:s");
	    $typec="2";
	    $newcomm="$messerr  cpt: unknown";
	    $pattern = "'$userid','$datecomm','$origin','$newcomm','$typec'";
	    $typec='U';
	    $pattern = "'$userid','$datecomm','$origin','$newcomm','$typec'";
	    $result2=simplewrite($conn,$pattern,"comments");
	    cleanresult($result2);
	}
}
//--------------------------------------------------------------------------
//Add bandwidth in cptinfo
// interface  1= client  2=support
//--------------------------------------------------------------------------
function check_addbandw($conn, $base, $numcnt, $product, $userid, $userid_sec, $mess,$interface,$remuser)
{
  if (!$userid) {
    $pattern2 = "WHERE numcnt = $numcnt";
    $resultcont2=simplesearch($conn,$pattern2,"contract");
    $rowscon2=numrows($resultcont2);
    if ($rowscon2>0) {
      $userid=getresult($resultcont2,0,'billedto');
    }
  }
  $pattern2 = "WHERE numcnt = $numcnt";
  $resultcon2=simplesearch($conn,$pattern2,"invoiced");
  $rowscon2=numrows($resultcon2);
  //                                                                    
  for ($xx=0;$xx<$rowscon2;$xx++) {
    $product=getresult($resultcon2,$xx,'product');
    $quantity=getresult($resultcon2,$xx,'quantity');
    $pattern2 = "WHERE prodname= '$product' and prodtype='B'";
    $resultp=simplesearch($conn,$pattern2,"products");
    $rowsp=numrows($resultp);
    if ($rowsp==1) {
      $userid_sec=getresult($resultcont2,0,'billedto');
      $comm_voip="start";
      $comment_voip="$hretcoll $remuser";
      $comment_voip=ereg_replace("'","''",$comment_voip);
      $mess=ereg_replace("'","''",$mess);
      include (direcname("$base","updvoip.php"));
      $j=0;
      while ($j<$quantity) {
	addbandw($conn,$base,$product,$userid,$userid_sec,$mess,$interface,$remuser);
	$j++;
      }
    }
  }

}
//--------------------------------------------------------------------------
//
//
//--------------------------------------------------------------------------
function find_type($conn, $base, $numcnt, $userid)
{
  $oldtype="";
  if ($userid) {
    $patt2 = "WHERE userid = '$userid'";
    $resultu=simplesearch($conn,$patt2,"userbill");
    $rowsu=numrows($resultu);
    if ($rowsu>0) {
      $numcnt=getresult($resultu,0,'curinvseq');
    }
  }
  if ($numcnt) {
  $patt="where numcnt=$numcnt";
  $result=simplesearch($conn,$patt,"contract");
  $rows=numrows($result);
  $oldtype='';
  $oldprod='';
  if ($rows>0) {
    $oldprod=getresult($result,0,'product');
    $patt="where prodname='$oldprod'";
    $result=simplesearch($conn,$patt,"products");
    $rows=numrows($result);
    if ($rows>0)
      $oldtype=getresult($result,0,'producttype');
  }
  }
  return $oldtype;
  
}

?>

