#!/bin/sh
#-------------------------------------------------------------------------
# cleanlog    This shell script takes care of cleaning the Regulus logs
#	      This shell script is (and should be) run every night.
# parameters are $1=BASE
#-------------------------------------------------------------------------
#
#
#Gzipping all previous days Regulus journals 
base=$1/var/lib/regulus2
for d in data data_cust
  do
  (
  cd $base/$d
  #extract older than 2 day logs file.
  find . -maxdepth 1  -name "*.jrl" -mtime +0 -exec mv {} .Old \;
  /bin/gzip .Old/*.jrl
  )
  done
exit 0
