#!/bin/sh
#Program to load stickers bacth
#
# $1 = input file (with directory)
# $2 = product
# $3 = Renewal time (month)
# $4 = Validity batch until (YYYYMMDD)
# $5 = Retailer
# $6 = Y=Paid N=Nopaid
# $7 = Week's grace
# $8 = base
#-------------------------------------------------------------------------
export lang='English'
#--------------------------------------------------------------------------
#avoiding any race condition
LOCK=/tmp/sticker.sh.lock
if [ -x /usr/bin/shlock ] ; then
  until /usr/bin/shlock -p $$ -f $LOCK
    do
    sleep 1
    done
fi
#-------------------------------------------------------------------------
cd `dirname $0`
#-------------------------------------------------------------------------
#loading mail configuration
                                                                              
if [ ! -n "$1" ]; then # no preset base set in the environement
    base=/var/lib/regulus2
else
    base=$8
fi

. $base/conf/act.conf
export regconf=$base/conf/regulus.php
#-------------------------------------------------------------------------
export inputfile=$1
export nprod=$2
export rentime=$3
export validate=$4
export retail=$5
export batchpaid=$6
export grace=$7
export remuser2=cron
#nice -19  ../reg-cgi/php -c ../php -q ../html/loadsticker.php > /dev/null &
../reg-cgi/php -c ../php -q ../html/loadsticker.php
#--------------------------------------------------------------------------
