#! /bin/sh                                                                    
#programme qui dump la database de regulus et la transfert sur un            
#autre systeme.                                                               
if [ ! -n "$1" ]; then # no preset base set in the environement               
    base=/var/lib/regulus2
else
    base=$1
fi
. $base/conf/act.conf
export regconf=$base/conf/regulus.php

. $base/conf/regulus.conf
#---------------------------------------------------------------------  
#direc=/var/log/regulus
direc=$base/dump
filedump=$direc/regulus.tbl
filezip=$direc/regulus.tbl.gz
oldfiledump=$direc/regulus.tbl.gz.old
dbusr=`id -un`
#DBGFILE=/tmp/xx
#---------------------------------------------------------------------        
if [ ! -d $direc ]; then
    mkdir $direc
  fi
#---------------------------------------------------------------------   
case "$SQLBASE" in
  "postgresql" )
    SQL="/usr/bin/pg_dump -c -p $SQLPORT -U $dbusr"
    ;;
  "mysql" )
    SQL="/usr/bin/mysqldump -u $dbusr -B -s -P $SQLPORT "
    ;;
  *)
    echo "FATAL ERROR, 'SQLBASE' not defined"
    exit
    ;;
esac
#/bin/echo "SQL=<"$SQL">" >> $DBGFILE
#---------------------------------------------------------------------    
today=`date '+%Y-%m-%d'`
if [ -f $filedump ] ; then
mv $filezip $oldfiledump
fi

if [ `id -u` = 0 ]; then
    dump=`/bin/su -m - $dbusr -c "$SQL regulus > $filedump"`
else
    dump=`$SQL regulus > $filedump`
fi
gzip $filedump
#if [ -f $filezip -a -s $filezip ] ; then
#scp $filezip diane@longueuil.safe.ca:regulus.tbl.gz.$today
#filessh=`ssh -Y -l diane longueuil.safe.ca ls regulus.tbl.gz.$today`
#if [ -n "$filessh" ] ; then
#if [ $filessh = regulus.tbl.gz.$today ] ; then
#rm $oldfiledump
#ssh -Y -l diane longueuil.safe.ca "find /home/regulus/regulus.tbl.* -mtime +49 -exec rm -f {} \;"
#fi
#fi
#fi
today=`date '+%Y-%m-%d'`
( echo "Subject: Regulus backup Database" ; echo "fichiers sur $direc"; ls -ails $direc ; echo ; echo "df" ; df $direc  ) | /usr/lib/sendmail diane@safe.ca
#( echo "Subject: Regulus backup Database" ; echo "fichiers sur $direc"; ls -ails $direc ; echo ; echo "df" ; df $direc ; echo ;  echo "fichiers sur longueuil" ; ssh -Y -l diane longueuil.safe.ca ls -ails regulus.tbl.* ; echo ; echo "df" ; ssh -Y -l diane longueuil.safe.ca  df) | /usr/lib/sendmail diane@safe.ca
