#! /bin/sh
#---------------------------------------------------------------------
#this is a shell script to update remote VOIP controler
#to allow/disallow access or to restrict call to local
#call
#
#  parameters:
#  action      "STOP"|"START"
#  userid      user
#
#---------------------------------------------------------------------
APPNAME=regulldap
ID=`id -u -n`
OUT=$APPNAME.$ID.out
#avoiding any race condition
LOCK=/tmp/$APPNAME.sh.lock
trap "rm -f $LOCK ; exit 1" 1 2 3 15
lockfile -1 $LOCK
date >> /tmp/$OUT
/bin/echo  "$APPNAME.sh  action=$1 userid=$2" >> /tmp/$OUT
/bin/echo "#-----------------------" >> /tmp/$OUT
rm -f $LOCK
