#! /bin/sh
#-----------------------------------------------------
#script to repair a data-base contents
# $1 BASE 		(usually /var/lib/regulus2)
# $2 SQLPORT		(PORT to access the data-base)
#Beware:
#	This utility must be run while being user regulus
#	The data-base damon must be running (on port SQLPORT)
#-----------------------------------------------------
#checking is there unwanted double.
/bin/echo "userbill double need to be manually removed"
psql -p $S2 -c "select userid from userbill" regulus | sort | uniq -d
/bin/echo "userreg double need to be manually removed"
psql -p $2 -c "select userid from userreg" regulus | sort | uniq -d
#-----------------------------------------------------------------------
/bin/echo "recreating the userreg index"
psql -p $2 -c"drop index userreg_userid_key;create unique index userreg_userid_key on userreg(userid)" regulus
/bin/echo "recreating the userbill index"
psql -p $2 -c"drop index userbill_userid_key;create unique index userbill_userid_key on userbill(userid)" regulus
