#!/bin/sh
#Program to locate and recurring contract which has not yet been
#activated.
#If the date apply, the previously issued (invoice.sh) recurring
#contract will be applied.
#That allow to have contract issued event if the contract doesn't
#connect itself in due time, allowing to issue the next
#recurring contract.
#That will only apply on recurring contract with automatic billing
#set to Yes (see the customer contract part, recurring contract line)
#-------------------------------------------------------------------------
cd `dirname $0`
export lang='English'
#-------------------------------------------------------------------------
#loading mail configuration
if [ ! -n "$1" ]; then # no preset base set in the environement
    base=/var/lib/regulus2
else
    base=$1
fi
. $base/conf/act.conf
export regconf=$base/conf/regulus.php
#--------------------------------------------------------------------------
export remuser2=cron
export lang='English'
$base/reg-cgi/php -c $base/php -q $base/html/lstccppa.php > /dev/null
#--------------------------------------------------------------------------
today=`date '+%Y-%m-%d'`
( echo "Subject: Regulus CCPPA ok" ; cat $base/list/ccppaj.$today ; cat $base/list/ccppa.$today ) | /usr/lib/sendmail $ACCTMNG
( echo "Subject: Regulus CCPPA refuse" ; cat $base/list/ccpparj.$today ; cat $base/list/ccppar.$today ) | /usr/lib/sendmail $ACCTMNG
