#!/bin/sh
#Program to list and paid invoice with credit card or banking_draft
#-------------------------------------------------------------------------
export lang='English'
#-------------------------------------------------------------------------
cd `dirname $0`
#-------------------------------------------------------------------------
#loading mail configuration
if [ ! -n "$1" ]; then # no preset base set in the environement
    base=/var/lib/regulus2
else
    base=$1
fi
. $base/conf/act.conf
export regconf=$base/conf/regulus.php
. $base/conf/regulus.conf
#--------------------------------------------------------------------------
#setting up the SQL parameter                                                   
owner=`ls -do $base/dbm | tr -s ' ' |  cut -f 3 -d" "`
#/bin/echo "owner =$owner" >> $DBGFILE
case "$SQLBASE" in
  "postgresql" )
    SQL="/usr/bin/psql -q -t -p $SQLPORT -c"
    ;;
  "mysql" )
    SQL="/usr/bin/mysql --socket=$base/dbm/mysql.sock -u $dbusr -B -s -P $SQLPORT -e"
    ;;
  *)
    echo "FATAL ERROR, 'SQLBASE' not defined"
    exit
    ;;
esac



#--------------------------------------------------------------------------
export lang='English'
export remuser2=cron
$base/reg-cgi/php -c $base/php -q $base/html/lstdateann.php > /dev/null
#--------------------------------------------------------------------------

pid=$$
$SQL "select * from dateann order by userid" regulus >> /tmp/dateann.$pid
$SQL "drop table dateann" regulus 
today=`date '+%Y-%m-%d'`
( echo "Subject: Liste Date d'anniversaire" ; echo '' ; cat /tmp/dateann.$pid ) | /usr/lib/sendmail $ACCTMNG
rm /tmp/dateann.$pid
