#! /bin/sh
#-------------------------------------------------------
#Process to upload a (very) small data-base, provided
#for test pupose.
#-------------------------------------------------------
# Source function library.
. /etc/rc.d/init.d/functions 
base=$racine/var/lib/regulus2

if [ -f $base/etc/regulus2.conf ]; then
  . $base/etc/regulus2.conf
fi

if [ ! -n "$base" ]; then  #standard starting
  export OPER=regulus
  export SQLPORT=1610
else  #manual install
  export SQLPORT="-p $sqlport"
fi

#to have no warning message while we start Regulus
unset BASH_ENV

/bin/su $OPER -c "\
$base/bin/rgmaster -b $BASE ; \
if [ -x /usr/bin/dropdb ]; then \
  /usr/bin/dropdb $SQLPORT regulus ;\
else
  /usr/bin/destroydb $SQLPORT regulus ;\
fi ; \
/usr/bin/createdb $SQLPORT regulus ;\
psql -q $SQLPORT \
  -c\"DELETE FROM pg_shadow WHERE usename='nobody'\" regulus ; \
psql -q $SQLPORT \
  -c\"INSERT INTO pg_shadow VALUES ('nobody',99,'t','t','f','t')\" regulus ;\
cat $base/demo/tstdata/tstbase-postgresql.tbl | \
  psql -q $SQLPORT regulus regulus ; \
"

kill -TERM `cat /tmp/LCK.rgmaster2-$SQLPORT` 
/bin/echo "TEST data-base uploaded"
exit 0

