#! /bin/sh
#----------------------------------------------------------
#shell to convert Regulus-1.4.1.X data-base to a Regulus-2.0.0.X data-base
# $1 is the home directory for the previous Regulus.
# CAUTION!
# The previous Regulus directories must be own by the pseudo user
# Regulus
#----------------------------------------------------------
unset BASH_ENV

export BASE=/var/lib/regulus2
export DBASE=regulus
export SQLPORT=1610
export OPER=regulus
export OLD=$1
#----------------------------------------------------------
#shutting down the current regulus-2 daemon (to be sure)
#----------------------------------------------------------
/bin/echo "Shutting down Regulus-2.0.X.X main daemon"
$BASE/shell/regulus stop
sleep 4
#----------------------------------------------------------
#setting the convertion directory
#----------------------------------------------------------
if [ -z $OLD ]; then
  OLD=/var/lib/regulus
fi
echo "Converting date from "$OLD
#----------------------------------------------------------
#changing data-base owner ship
#----------------------------------------------------------
/bin/echo "checking data-base ownership"
(cd $OLD ; chown -R $OPER dbm )
#----------------------------------------------------------
#stating convertion
#----------------------------------------------------------
/bin/echo starting convertion
/bin/su -c `pwd`/subconvert.sh $OPER
#----------------------------------------------------------
/bin/echo "Data-base convertion now fully completed."
/bin/echo "Now restarting Regulus main daemon"
$BASE/shell/regulus start
